<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\TkDI;
use HCM\FPA\Calculos\Geral\EventosFaltasIntervalo;
use HCM\Geral\Entity\GpepessoaEntity;
use HCM\Geral\Entity\GpevinculomEntity;
use HCM\Geral\Entity\GpevinculohEntity;
use HCM\Geral\Entity\GpeescalatrabmEntity;
use HCM\Geral\Entity\GpesitufuncmEntity;
use HCM\Geral\Entity\GpealtesitufuncEntity;
use HCM\FPA\Entity\FpadepvinculoEntity;
use HCM\FPA\Entity\FpatipodependeEntity;
use HCM\FPA\Entity\FpaferiasEntity;
use HCM\FPA\Entity\FpagozoferiasEntity;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\FPA\Entity\FpatpcalcmovEntity;
use HCM\FPA\Entity\FpacalculofolhaEntity;
use HCM\FPA\Entity\FpaitecalcfolhaEntity;
use HCM\FPA\Entity\FpaeventomEntity;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\FPA\Entity\FpaassoceventoEntity;

class Inicializa{

    static $container;
    static $_listaEventoHoraExtra;
    static $_listaEventoAdicionalNoturno;

    public static function Container($entityManager, $hcmParameters, $dtPagamento = null) {
        
        self::$container = TkDI::getContainer();

        self::$container->pessoa = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new GpepessoaEntity($entityManager, $hcmParameters);
            }
        );
        self::$container->vinculom = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new GpevinculomEntity($entityManager, $hcmParameters);
            }
        );
        self::$container->vinculoh = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new GpevinculohEntity($entityManager, $hcmParameters);
            }
        );
        self::$container->dependencia = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpadepvinculoEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->tipo_dependencia = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpatipodependeEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->escalam = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new GpeescalatrabmEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->situacao_funcional = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new GpesitufuncmEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->alteracao_situacao_funcional = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new GpealtesitufuncEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->ferias = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpaferiasEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->gozo_ferias = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpagozoferiasEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->faltas_intervalo = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new EventosFaltasIntervalo($entityManager, $hcmParameters);
            }
        );
        
        self::$container->tipo_calculo = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpatipocalculoEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->tp_calc_mov = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpatpcalcmovEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->calculo_folha = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpacalculofolhaEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->itens_calculo = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpaitecalcfolhaEntity($entityManager, $hcmParameters);
            }
        );
        
        self::$container->eventom = self::$container->asShared(
            function() use($entityManager, $hcmParameters, $dtPagamento){
                return new FpaeventomEntity($entityManager, $hcmParameters, $dtPagamento);
            }
        );

        self::$container->tipo_assoc = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpatipoassoceveEntity($entityManager, $hcmParameters);
            }
        );

        self::$container->assoc_eventos = self::$container->asShared(
            function() use($entityManager, $hcmParameters){
                return new FpaassoceventoEntity($entityManager, $hcmParameters);
            }
        );
        
        self::$container->param_calculo = self::$container->asShared(
            function() use($entityManager, $hcmParameters) {
                return new ParametrosCalculo($entityManager, $hcmParameters);
            }
        );
    }

    public static function carregaVariaveis(){
        self::_carregaHoraExtra();
        self::_carregaAdicionalNoturno();
    }

    private static function _carregaHoraExtra(){

        $tipoAssociacao = self::$container->tipo_assoc;
        $horasExtra = $tipoAssociacao->getHoraExtra();
        self::$_listaEventoHoraExtra = self::$container->assoc_eventos->determinaReferenciaEventoAssociado(
            $horasExtra, self::$container->eventom
        );
    }

    public static function getListaEventoHoraExtra(){
        return self::$_listaEventoHoraExtra;
    }

    private static function _carregaAdicionalNoturno(){

        $tipoAssociacao = self::$container->tipo_assoc;
        $adicionalNoturno = $tipoAssociacao->getAdicionalNoturno();
        self::$_listaEventoAdicionalNoturno = self::$container->assoc_eventos->determinaReferenciaEventoAssociado(

        $adicionalNoturno, self::$container->eventom
        );
    }

    public static function getListaEventoAdicionalNoturno(){
        return self::$_listaEventoAdicionalNoturno;
    }

}