<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Geral\Repository\ParametrizacaoEsocialRepository;
use HCM\Util\HCMParameters;


class ParametrizacaoEsocialService {

    public function __construct(EntityManager $entityManager, ParametrizacaoEsocialRepository $parametrizacaoEsocialRepository, HCMParameters $hcmParameters)
    {
        $this->entityManager = $entityManager;
        $this->parametrizacaoEsocialRepository = $parametrizacaoEsocialRepository;
        $this->hcmParameters = $hcmParameters;
    }

    public function cadastroAutomaticoParametrizacaoEsocial($nreventom, $savecrud = false)
    {   
        $existeNaturezaRubricaEvento = self::buscaEventoComNaturezaRubrica($nreventom);
        if(empty($existeNaturezaRubricaEvento)) {
            if($savecrud) {
                return;
            } else {
                return 'erroNaturezaRubrica';
            }
            
        }

        $arrayParametrizacaoEsocial = $this->parametrizacaoEsocialRepository->geraInsertParametrizacaoEsocial($nreventom);
        
        if(!empty($arrayParametrizacaoEsocial)) {
            $insereParametrizacaoEsocial = self::insereParametrizacaoEsocial($nreventom, $arrayParametrizacaoEsocial);
            return $insereParametrizacaoEsocial;
        }

        return false;
    }

    public function buscaEventoComNaturezaRubrica($nreventom)
    {   
        $existeNaturezaRubricaEvento = $this->parametrizacaoEsocialRepository->buscaEventoComNaturezaRubrica($nreventom);
        return $existeNaturezaRubricaEvento ;
    }

    public function insereParametrizacaoEsocial($nreventom, $arrayParametrizacaoEsocial)
    {   
        $save = false;
        
        foreach ($arrayParametrizacaoEsocial as $parametrizacaoEsocial) {
            $parametrizacaoEsocial["NRORG"] = $this->hcmParameters->getNrorgTrabalho();
            
            $esorubrica = self::existeParametrizacaoEsocial($parametrizacaoEsocial);
            
            if(is_object($esorubrica)){
                $retorno = $this->parametrizacaoEsocialRepository->atualizaParametrizacaoEsocial($esorubrica, $parametrizacaoEsocial);
            } else {
                $retorno = $this->parametrizacaoEsocialRepository->insereParametrizacaoEsocial($parametrizacaoEsocial);
            }

            if(is_object($retorno)) {
                $save = true;
            }
        }

        return $save;
    }
    
    public function existeParametrizacaoEsocial($parametrizacaoEsocial)
    {   
        $esorubrica = $this->entityManager->getRepository(Repositories::ESO_RUBRICA)->findOneBy(
            array('nreventom' => $parametrizacaoEsocial["NREVENTOM"], 'nrorg' => $parametrizacaoEsocial["NRORG"], 'nrtipomoviment' => $parametrizacaoEsocial["NRTIPOMOVIMENT"])
        );
        return $esorubrica;
    }
}