<?php
namespace HCM\PTO\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class MotivoSituFuncRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function verificaExistenciaMotivoSituFunc($nrorg, $nrmotivoocorfreq, $nrsitufuncm, $nrmotivositufunc=null) {
        
        $query = <<<SQL
SELECT *
  FROM PTO_MOTIVOSITUFUNC
 WHERE NRORG = :P_NRORG
   AND ( NRMOTIVOOCORFREQ = :P_NRMOTIVOOCORFREQ OR NRSITUFUNCM = :P_NRSITUFUNCM )
   AND ( NRMOTIVOSITUFUNC <> :P_NRMOTIVOSITUFUNC OR :P_NRMOTIVOSITUFUNC IS NULL )
SQL;
        
        $parameters = array(
            "P_NRORG" => $nrorg,
            "P_NRMOTIVOOCORFREQ" => $nrmotivoocorfreq,
            "P_NRSITUFUNCM" => $nrsitufuncm,
            "P_NRMOTIVOSITUFUNC" => $nrmotivositufunc,
        );
        
        $result = $this->connection->fetchAll($query, $parameters);

        return $result;
        
    }

}