<?php

namespace HCM\SST\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;
use HCM\SST\Services\RelatCustomSegTrabService;

class RelatCustomSegTrabController extends Crud {

    public function __construct (Manager $dataSourceManager, RelatCustomSegTrabService $RelatCustomSegTrabService){
        $this->RelatCustomSegTrabService = $RelatCustomSegTrabService;
        parent::__construct($dataSourceManager);
    }

    public function getRelatCustomSegTrab(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            set_time_limit(0);
            
            $filters = \HCM\Util\Util::removerCaracterePorcentagemString($request->getFilterCriteria()->getConditions());
            $result = $this->RelatCustomSegTrabService->getRelatCustomSegTrab($filters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getRelatCustomSegTrab', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }
} 