-- ============================================================
-- Database name: GPE_VAB
-- DBMS name: ORACLE Version 7.x float
-- Created on: 13/06/2016 16:08
-- ============================================================
-- ============================================================
-- Table: TPBENEFICIO
-- ============================================================
create table TPBENEFICIO
(
NRORG NUMBER NOT NULL,
NRTPBENEFICIO NUMBER not null,
DSTPBENEFICIO VARCHAR2(50) not null,
IDATIVO VARCHAR2(1) default 'S' null
constraint CKC_IDATIVO_TPBENEFICIO check (
IDATIVO is null or (IDATIVO in ('S','N'))),
NRORGINCLUSAO NUMBER default 1 null ,
DTINCLUSAO DATE not null ,
CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
NRORGULTATU NUMBER default 1 null ,
DTULTATU DATE null ,
CDOPERULTATU VARCHAR2(12) default '1' null ,
constraint PK_TPBENEFICIO primary key (NRORG, NRTPBENEFICIO)
)
/
-- ============================================================
-- Table: FORMABENEFICIO
-- ============================================================
create table FORMABENEFICIO
(
NRORG NUMBER NOT NULL,
NRFORMABENEFICIO NUMBER not null,
DSFORMABENEFICIO VARCHAR2(100) not null,
IDATIVO VARCHAR2(1) default 'S' null
constraint CKC_IDATIVO_FORMABENEFICIO check (
IDATIVO is null or (IDATIVO in ('S','N'))),
NRORGINCLUSAO NUMBER default 1 null ,
DTINCLUSAO DATE not null ,
CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
NRORGULTATU NUMBER default 1 null ,
DTULTATU DATE null ,
CDOPERULTATU VARCHAR2(12) default '1' null ,
constraint PK_FORMABENEFICIO primary key (NRORG, NRFORMABENEFICIO)
)
/
-- ============================================================
-- Table: VAB_BENEFICIOM
-- ============================================================
create table VAB_BENEFICIOM
(
NRORG NUMBER NOT NULL,
NRBENEFICIOM NUMBER not null,
DTINICIOVIGENCIA DATE not null,
DTFINALVIGENCIA DATE null ,
IDATIVO VARCHAR2(1) default 'S' null
constraint CKC_IDATIVO_VAB_BENEFICIOM check (
IDATIVO is null or (IDATIVO in ('S','N'))),
NRORGINCLUSAO NUMBER default 1 null ,
DTINCLUSAO DATE not null ,
CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
NRORGULTATU NUMBER default 1 null ,
DTULTATU DATE null ,
CDOPERULTATU VARCHAR2(12) default '1' null ,
constraint PK_VAB_BENEFICIOM primary key (NRORG, NRBENEFICIOM)
)
/
-- ============================================================
-- Table: VAB_BENEFICIOH
-- ============================================================
create table VAB_BENEFICIOH
(
NRORG NUMBER NOT NULL,
NRBENEFICIOH NUMBER not null,
NRBENEFICIOM NUMBER not null,
NRTPBENEFICIO NUMBER not null,
NRFORMABENEFICIO NUMBER not null,
NRESTRUTURAM NUMBER not null,
DTMESCOMPETENC DATE not null,
DTREFERENCIA DATE null ,
DSBENEFICIO VARCHAR2(100) not null,
TPPERIODOBENEF VARCHAR2(10) not null,
DSOBSBENEFICIO VARCHAR2(2000) null ,
NRTABELAFOLHAPRI NUMBER null,
NRTABELAFOLHASEC NUMBER null ,
IDATIVO VARCHAR2(1) default 'S' null
constraint CKC_IDATIVO_VAB_BENEFICIOH check (
IDATIVO is null or (IDATIVO in ('S','N'))),
NRORGINCLUSAO NUMBER default 1 null ,
DTINCLUSAO DATE not null ,
CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
NRORGULTATU NUMBER default 1 null ,
DTULTATU DATE null ,
CDOPERULTATU VARCHAR2(12) default '1' null ,
constraint PK_VAB_BENEFICIOH primary key (NRORG, NRBENEFICIOH)
)
/
-- ============================================================
-- Index: VAB00020_FK
-- ============================================================
create index VAB00020_FK on VAB_BENEFICIOH (NRORG asc, NRTPBENEFICIO asc)
/
-- ============================================================
-- Index: VAB00025_FK
-- ============================================================
create index VAB00025_FK on VAB_BENEFICIOH (NRORG asc, NRFORMABENEFICIO asc)
/
-- ============================================================
-- Index: VAB00021_FK
-- ============================================================
create index VAB00021_FK on VAB_BENEFICIOH (NRORG asc, NRESTRUTURAM asc)
/
-- ============================================================
-- Index: VAB00026_FK
-- ============================================================
create index VAB00026_FK on VAB_BENEFICIOH (NRORG asc, NRBENEFICIOM asc)
/
-- ============================================================
-- Table: VAB_BENEFICIARIO
-- ============================================================
create table VAB_BENEFICIARIO
(
NRORG NUMBER NOT NULL,
NRBENEFICIARIO NUMBER not null,
NRBENEFICIOM NUMBER not null,
NRVINCULOM NUMBER not null,
NRPESSOA NUMBER not null,
NREVENTOM NUMBER not null,
NRINTEGTRANSPM NUMBER null ,
NRVALORREFERENCIAM NUMBER null ,
NRVINCEVENTO NUMBER null ,
DTINSCBENEFICIARIO DATE not null,
NRINSCBENEFICIARIO VARCHAR2(100) null,
DTCANCBENEFICIARIO DATE null ,
QTBENEFICIO FLOAT not null,
VRBENEFICIO FLOAT null ,
IDTPBENEFICIARIO VARCHAR2(1) not null
constraint CKC_4365 check (IDTPBENEFICIARIO in ('T','D')),
IDVALORDIFEBENEF VARCHAR2(20) default 'TABELA' not null
constraint CKC_5122 check (IDVALORDIFEBENEF in ('TABELA','REFERENCIA','VALOR')),
DSOBSBENEFICIARIO VARCHAR2(2000) null ,
IDATIVO VARCHAR2(1) default 'S' null
constraint CKC_IDATIVO_VAB_BENEFICIARIO check (
IDATIVO is null or (IDATIVO in ('S','N'))),
NRORGINCLUSAO NUMBER default 1 null ,
DTINCLUSAO DATE not null ,
CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
NRORGULTATU NUMBER default 1 null ,
DTULTATU DATE null ,
CDOPERULTATU VARCHAR2(12) default '1' null ,
constraint PK_VAB_BENEFICIARI primary key (NRORG, NRBENEFICIARIO)
)
/
-- ============================================================
-- Index: VAB00027_FK
-- ============================================================
create index VAB00027_FK on VAB_BENEFICIARIO (NRORG asc, NRBENEFICIOM asc)
/
-- ============================================================
-- Index: VAB00028_FK
-- ============================================================
create index VAB00028_FK on VAB_BENEFICIARIO (NRORG asc, NRVINCULOM asc)
/
-- ============================================================
-- Index: VAB00029_FK
-- ============================================================
create index VAB00029_FK on VAB_BENEFICIARIO (NRORG asc, NRPESSOA asc)
/
-- ============================================================
-- Index: VAB00030_FK
-- ============================================================
create index VAB00030_FK on VAB_BENEFICIARIO (NRORG asc, NREVENTOM asc)
/
-- ============================================================
-- Index: VAB00031_FK
-- ============================================================
create index VAB00031_FK on VAB_BENEFICIARIO (NRORG asc, NRINTEGTRANSPM asc)
/
-- ============================================================
-- Index: VAB00032_FK
-- ============================================================
create index VAB00032_FK on VAB_BENEFICIARIO (NRVALORREFERENCIAM asc)
/
-- ============================================================
-- Index: VAB00033_FK
-- ============================================================
create index VAB00033_FK on VAB_BENEFICIARIO (NRORG asc, NRVINCEVENTO asc)
/
-- ============================================================
-- Table: VAB_FORMCALCBENEF
-- ============================================================
create table VAB_FORMCALCBENEF
(
NRORG NUMBER NOT NULL,
NRFORMCALCBENEF NUMBER not null,
NRTPBENEFICIO NUMBER null ,
NRESTRUTURAM NUMBER null ,
DSFORMCALCBENEF VARCHAR2(100) not null,
DSORDEMCALCBENEF VARCHAR2(100) not null,
DSINICIOCALCBENEF VARCHAR2(1000) null,
DSFIMCALCBENEF VARCHAR2(1000) null,
DTINICALCBENEF DATE not null,
DTFIMCALCBENEF DATE not null,
DTPGTOCALCBENEF DATE not null,
IDATIVO VARCHAR2(1) default 'S' null
constraint CKC_IDATIVO_VAB_FORMCALCBENEF check (
IDATIVO is null or (IDATIVO in ('S','N'))),
NRORGINCLUSAO NUMBER default 1 null ,
DTINCLUSAO DATE not null ,
CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
NRORGULTATU NUMBER default 1 null ,
DTULTATU DATE null ,
CDOPERULTATU VARCHAR2(12) default '1' null ,
constraint PK_VAB_FORMCALCBEN primary key (NRORG, NRFORMCALCBENEF)
)
/
-- ============================================================
-- Index: VAB00034_FK
-- ============================================================
create index VAB00034_FK on VAB_FORMCALCBENEF (NRORG asc, NRTPBENEFICIO asc)
/
-- ============================================================
-- Index: VAB00035_FK
-- ============================================================
create index VAB00035_FK on VAB_FORMCALCBENEF (NRORG asc, NRESTRUTURAM asc)
/
-- ============================================================
-- Table: VAB_HISTBENEFVINC
-- ============================================================
CREATE TABLE VAB_HISTBENEFVINC
(
	NRHISTBENEFVINC NUMBER NOT NULL,
	NRBENEFICIOM NUMBER NOT NULL,
	NRVINCULOM NUMBER NOT NULL,
	NRCALCULOFOLHA NUMBER NOT NULL,
	NREVENTOM NUMBER NOT NULL,
	NRORG NUMBER DEFAULT 1 NOT NULL,
	DTMESCOMPETENC DATE NOT NULL,
	DTINIAPURBENEF DATE NOT NULL,
	DTFINAPURBENEF DATE NOT NULL,
	DTPGTOBENEF DATE,
	QTAPURBENEF FLOAT(126) NOT NULL,
	QTDIASBENEF FLOAT(126) NOT NULL,
	QTDIASFALTAS FLOAT(126) NOT NULL,
	QTDIASAFASTA FLOAT(126) NOT NULL,
	QTDIASFERIAS FLOAT(126) NOT NULL,
	QTDIASAVISO FLOAT(126) NOT NULL,
	QTDIASDSR FLOAT(126) NOT NULL,
	VRBENEFICIO FLOAT(126),
	VRDEDUCAOBENEF FLOAT(126),
	VRTOTALBENEF FLOAT(126),
	IDATIVO VARCHAR2(1) DEFAULT 'S' NULL
    CONSTRAINT CKC_IDATIVO_HISTBENEFVINC CHECK (
      IDATIVO is null or (IDATIVO in ('S','N'))),
	NRORGINCLUSAO NUMBER DEFAULT 1,
	DTINCLUSAO DATE,
	CDOPERINCLUSAO VARCHAR2(12 BYTE) DEFAULT '1',
	NRORGULTATU NUMBER DEFAULT 1,
	DTULTATU DATE,
	CDOPERULTATU VARCHAR2(12 BYTE) DEFAULT '1',
	 CONSTRAINT PK_VAB_HISTBENEFVI PRIMARY KEY (NRORG, NRHISTBENEFVINC)
)
/
-- ============================================================
-- Index: VAB00036_FK
-- ============================================================
CREATE INDEX VAB00036_FK ON VAB_HISTBENEFVINC (NRORG, NRBENEFICIOM)
/
-- ============================================================
-- Index: VAB00037_FK
-- ============================================================
CREATE INDEX VAB00037_FK ON VAB_HISTBENEFVINC (NRORG, NRVINCULOM)
/
-- ============================================================
-- Index: VAB00038_FK
-- ============================================================
CREATE INDEX VAB00038_FK ON VAB_HISTBENEFVINC (NRCALCULOFOLHA, NRORG)
/
alter table VAB_BENEFICIOH
add constraint FKVAB00020TPBENEFI foreign key (NRORG, NRTPBENEFICIO)
references TPBENEFICIO (NRORG, NRTPBENEFICIO)
/
alter table VAB_BENEFICIOH
add constraint FKVAB00025FORMABEN foreign key (NRORG, NRFORMABENEFICIO)
references FORMABENEFICIO (NRORG, NRFORMABENEFICIO)
/
alter table VAB_BENEFICIOH
add constraint FKVAB00021ESTRUTUR foreign key (NRESTRUTURAM, NRORG)
references SA_ESTRUTURAM (NRESTRUTURAM, NRORG)
/
alter table VAB_BENEFICIOH
add constraint FKVAB00026VAB_BENE foreign key (NRORG, NRBENEFICIOM)
references VAB_BENEFICIOM (NRORG, NRBENEFICIOM)
/
alter table VAB_BENEFICIARIO
add constraint FKVAB00027VAB_BENE foreign key (NRORG, NRBENEFICIOM)
references VAB_BENEFICIOM (NRORG, NRBENEFICIOM)
/
alter table VAB_BENEFICIARIO
add constraint FKVAB00028GPE_VINC foreign key (NRORG, NRVINCULOM)
references GPE_VINCULOM (NRORG, NRVINCULOM)
/
alter table VAB_BENEFICIARIO
add constraint FKVAB00029GPE_PESS foreign key (NRORG, NRPESSOA)
references GPE_PESSOA (NRORG, NRPESSOA)
/
alter table VAB_BENEFICIARIO
add constraint FKVAB00030FPA_EVEN foreign key (NREVENTOM)
references FPA_EVENTOM (NREVENTOM)
/
alter table VAB_BENEFICIARIO
add constraint FKVAB00031VAB_INTE foreign key (NRORG, NRINTEGTRANSPM)
references VAB_INTEGTRANSPM (NRORG, NRINTEGTRANSPM)
/
alter table VAB_BENEFICIARIO
add constraint FKVAB00032FPA_VALO foreign key (NRVALORREFERENCIAM)
references FPA_VALORREFERENCIAM (NRVALORREFERENCIAM)
/
alter table VAB_BENEFICIARIO
add constraint FKVAB00033FPA_VINC foreign key (NRORG, NRVINCEVENTO)
references FPA_VINCEVENTO (NRORG, NRVINCEVENTO)
/
alter table VAB_FORMCALCBENEF
add constraint FKVAB00034TPBENEFI foreign key (NRORG, NRTPBENEFICIO)
references TPBENEFICIO (NRORG, NRTPBENEFICIO)
/
alter table VAB_FORMCALCBENEF
add constraint FKVAB00035ESTRUTUR foreign key (NRESTRUTURAM, NRORG)
references SA_ESTRUTURAM (NRESTRUTURAM, NRORG)
/
alter table VAB_BENEFICIOH
add constraint FKVAB00036FPA_TABE foreign key (NRTABELAFOLHAPRI)
references FPA_TABELAFOLHA (NRTABELAFOLHA)
/
alter table VAB_BENEFICIOH
add constraint FKVAB00037FPA_TABE foreign key (NRTABELAFOLHASEC)
references FPA_TABELAFOLHA (NRTABELAFOLHA)
/
ALTER TABLE VAB_HISTBENEFVINC
  ADD CONSTRAINT FKVAB00038VAB_BENE FOREIGN KEY (NRORG, NRBENEFICIOM)
    REFERENCES VAB_BENEFICIOM (NRORG, NRBENEFICIOM)
/
ALTER TABLE VAB_HISTBENEFVINC
  ADD CONSTRAINT FKVAB00039GPE_VINC FOREIGN KEY (NRVINCULOM, NRORG)
    REFERENCES GPE_VINCULOM (NRVINCULOM, NRORG)
/
ALTER TABLE VAB_HISTBENEFVINC
  ADD CONSTRAINT FKVAB00040FPA_CALC FOREIGN KEY (NRCALCULOFOLHA, NRORG)
	  REFERENCES FPA_CALCULOFOLHA (NRCALCULOFOLHA, NRORG)
/
ALTER TABLE VAB_HISTBENEFVINC
  ADD CONSTRAINT FKVAB00041FPA_EVEN FOREIGN KEY (NREVENTOM)
	  REFERENCES FPA_EVENTOM (NREVENTOM)
/
-- ============================================================
-- Table: FPA_TIPOMOVIMENT
-- ============================================================
INSERT INTO FPA_TIPOMOVIMENT
  VALUES (21, 'BENEFICIO', 'S', 0, SYSDATE, SYSDATE, 1, '1', 1, '1')
/