-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     24/05/2023  12:00                        
--   Issue:          425989 - IMPLEMENTAÇÃO TEKNISA - CRIAÇÃO DE LOTE PARA CALCULO

-- ============================================================
-- Table: FPA_LOTEVINC
-- ============================================================
CREATE TABLE FPA_LOTEVINC
(
    NRORG                 NUMBER          NOT NULL,
    NRLOTEVINC            NUMBER          NOT NULL,
    NMLOTEVINC            VARCHAR2(100)   NOT NULL,
    DTINIVIGENCIA         DATE            NOT NULL,
    DTFIMVIGENCIA         DATE            NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_LOTVIN CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_LOTEVINC PRIMARY KEY (NRORG, NRLOTEVINC)
)
/

-- ============================================================
-- Table: FPA_ITEMLOTEVINC
-- ============================================================
CREATE TABLE FPA_ITEMLOTEVINC
(
    NRORG                 NUMBER          NOT NULL,
    NRITEMLOTEVINC        NUMBER          NOT NULL,
    NRLOTEVINC            NUMBER          NOT NULL,
    NRVINCULOM            NUMBER          NOT NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_ITLOTVIN CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_ITEMLOTEVINC PRIMARY KEY (NRORG, NRITEMLOTEVINC),
    CONSTRAINT FK_ITLOTVIN_NRLOTVINC FOREIGN KEY (NRORG, NRLOTEVINC) REFERENCES FPA_LOTEVINC (NRORG, NRLOTEVINC),
    CONSTRAINT FK_ITLOTVIN_NRVINC FOREIGN KEY (NRORG, NRVINCULOM) REFERENCES GPE_VINCULOM (NRORG, NRVINCULOM)
)
/