-- ===============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 19.x 
--   Created on:     14/07/2023  14:53
--   Issue:          427541 - Permitir adicionar mais de 1 modelo de aprovação
-- ===============================================================

-- ===============================================================
--   Table: GPE_SOLICITACAO                                      
-- ===============================================================

ALTER TABLE GPE_SOLICITACAO ADD NRMODELOAPROVSOLI NUMBER NULL
/

ALTER TABLE GPE_SOLICITACAO ADD
    CONSTRAINT MODELOAPROVSOLI_SOLICITACAO_FK FOREIGN KEY (NRORG, NRMODELOAPROVSOLI)
    REFERENCES GPE_MODELOAPROVSOLI(NRORG, NRMODELOAPROVSOLI)
/
    
-- ============================================================
--   Table: GPE_PERFACESTIPOSOLI                                      
-- ============================================================
ALTER TABLE GPE_PERFACESTIPOSOLI ADD NRTIPOVINCULOM VARCHAR(4000) NULL
/

ALTER TABLE GPE_PERFACESTIPOSOLI ADD NRESTRUTLEGAL VARCHAR(4000) NULL
/

ALTER TABLE GPE_PERFACESTIPOSOLI ADD NRESTRUTGEREN VARCHAR(4000) NULL
/

ALTER TABLE GPE_PERFACESTIPOSOLI ADD NRESTRUTSIND VARCHAR(4000) NULL
/

ALTER TABLE GPE_PERFACESTIPOSOLI ADD NROCUPACAOM VARCHAR(4000) NULL
/

/* Atualiza solicitacoes que ja existem com o respectivo modelo atual */
UPDATE GPE_SOLICITACAO SOLI
SET NRMODELOAPROVSOLI = (
    SELECT
        PAS.NRMODELOAPROVSOLI
    FROM GPE_SOLICITACAO S
    LEFT JOIN GPE_PERFACESTIPOSOLI PAS ON PAS.NRORG = S.NRORG
        AND PAS.NRTIPOSOLICITACAO = S.NRTIPOSOLICITACAO
    WHERE S.NRORG = SOLI.NRORG
        AND S.NRSOLICITACAO = SOLI.NRSOLICITACAO
    ORDER BY PAS.DTINCLUSAO DESC
    FETCH FIRST ROW ONLY
)
WHERE SOLI.NRMODELOAPROVSOLI IS NULL
;
COMMIT;
