/************************************************************************************************/
/* Database name: TEKNISA_SAAS                                                                  */
/* Tabelas: GER_VERIFICACAO, GER_PARAMVERIFICA                                                  */
/*                                                                                              */
/* Criação:                                                                                     */
/* 11/09/2021 - Inserir validações relativas às verificações pré fechamento do eSocial          */
/*                                                                                              */
/************************************************************************************************/

/*Vínculos ativos com líquido e sem S1200 ou envio anterior ao cálculo*/  
INSERT INTO GER_VERIFICACAO (
    NRVERIFICACAO,
    NRTIPOVERIFICA,
    DSVERIFICACAO,
    MSGVERIFICACAO,
    DSCONSULTAVERIFICA,
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU,
    NRORG
) VALUES (
    27,
    2,
    'eSocial - Vínculos ativos com líquido e sem S1200 ou envio anterior ao cálculo',
    'eSocial - Vínculos ativos com líquido e sem S1200 ou envio anterior ao cálculo',
    'SELECT
    RES.NRPESSOA PESSOA,
    RES.NRVINCULOM||''-''||RES.NMVINCULOM VINCULO,
    TO_CHAR(RES.DTADMISSAOVINC,''DD/MM/YYYY'') ADMISSAO,
    TO_CHAR(RES.DTRESCISAOVINC,''DD/MM/YYYY'') RESCISAO,
    TO_CHAR(RES.DTLIQUIDO,''DD/MM/YYYY HH24:MI:SS'') DATA_LIQUIDO,
    TO_CHAR(ESOPE.DTENVIO,''DD/MM/YYYY HH24:MI:SS'') DATA_S1200,
    DECODE(ESOPE.IDSTATUS, ''M'', ''Em Processamento'', ''A'', ''Concluído com Advertências'', ''C'', ''Concluído'') STATUS_S1200
 FROM (SELECT
          VM.NRORG, VM.NRPESSOA, VM.NRVINCULOM, VM.NMVINCULOM, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, CF.NRTIPOMOVIMENT, CF.DTOCORRENCIA, EP.NRTPAMBIENTE,
          SUM(ICF.VREVENTOFOLHA) VRLIQUIDO, MAX(ICF.DTULTATU) DTLIQUIDO
        FROM GPE_VINCULOM VM
        JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                            AND VH.NRVINCULOM = VM.NRVINCULOM
                            AND VH.DTMESCOMPETENC = ( SELECT *
                                                      FROM ( SELECT DTMESCOMPETENC
                                                             FROM GPE_VINCULOH
                                                             WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                               AND NRORG      = VH.NRORG
                                                               AND NRVINCULOM = VH.NRVINCULOM
                                                             ORDER BY DTMESCOMPETENC DESC )
                                                       WHERE ROWNUM = 1 )
       JOIN ESO_PARAMETRO EP ON EP.NRORG = VH.NRORG
                            AND EP.NRESTRUTURAM = VH.NRESTRUTLEGAL
        /*CÁLCULO DE FOLHA*/
        JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG       = VM.NRORG
                                 AND ICF.NRVINCULOM  = VM.NRVINCULOM
                                 AND ICF.NREVENTOM IN (3030,3050)
                                 AND ICF.VREVENTOFOLHA > 0
        JOIN FPA_CALCULOFOLHA CF ON CF.NRORG            = ICF.NRORG
                                AND CF.NRCALCULOFOLHA   = ICF.NRCALCULOFOLHA
                                AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                                AND CF.NRTPMODALIDCAL = 1
                                AND CF.DTOCORRENCIA   = :P_DTMESCOMPETENC
        /**/
        WHERE VM.NRORG = :P_NRORG
          AND ( VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC) )
          AND ( VM.DTRESCISAOVINC > LAST_DAY(:P_DTMESCOMPETENC) OR VM.DTRESCISAOVINC IS NULL )
        GROUP BY VM.NRORG, VM.NRPESSOA, VM.NRVINCULOM, VM.NMVINCULOM, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, VH.NRESTRUTLEGAL, VH.NRESTRUTGEREN, CF.NRTIPOMOVIMENT, CF.DTOCORRENCIA, EP.NRTPAMBIENTE) RES
    LEFT JOIN (SELECT ESOPE.NRENVIO, ESOPE.NRESTRUTURAM, ESOPE.NRTPAMBIENTE, ESOPE.DTMESCOMPETENC, ESOPE.NRTABELA, ESOPE.NRCHAVE, ESOPE.IDSTATUS, ESOPE.DTENVIO
                 FROM ESO_PERIODICO ESOPE
                WHERE ESOPE.NRORG = :P_NRORG
                  AND ESOPE.DTMESCOMPETENC = :P_DTMESCOMPETENC
                  AND ESOPE.NMEVENTO = ''S-1200''
                  AND ESOPE.IDSTATUS IN (''C'',''A'',''M'')
                  AND ESOPE.IDATIVO = ''S'' AND ESOPE.NRENVIOEXCL IS NULL) ESOPE ON ESOPE.DTMESCOMPETENC = RES.DTOCORRENCIA
                                                                              AND ESOPE.NRTPAMBIENTE = RES.NRTPAMBIENTE
                                                                              AND ESOPE.NRCHAVE = RES.NRPESSOA
                                                                              AND ((RES.NRTIPOMOVIMENT IN (1,2,10,19) AND ESOPE.NRTABELA = 1) OR
                                                                                   (RES.NRTIPOMOVIMENT = 4 AND TO_CHAR(RES.DTOCORRENCIA,''MM'') <> ''12'' AND ESOPE.NRTABELA = 1) OR
                                                                                   (RES.NRTIPOMOVIMENT = 4 AND TO_CHAR(RES.DTOCORRENCIA,''MM'') = ''12'' AND ESOPE.NRTABELA = 4))
 WHERE ESOPE.NRENVIO IS NULL OR RES.DTLIQUIDO > ESOPE.DTENVIO',
    'S',
    1,
    sysdate,
    1,
    1,
    sysdate,
    1,
    0
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    27,     
    'P_NRORG',   
    '@\FPA::getNrorgTrabalho()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getNrorgTrabalho()@'
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    27,     
    'P_DTMESCOMPETENC',   
    '@\FPA::getDtCompetencia()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getDtCompetencia()@'
)
/

/************************************************************************************************/
/*Vínculos com rescisão sem S-2299*/  
INSERT INTO GER_VERIFICACAO (
    NRVERIFICACAO,
    NRTIPOVERIFICA,
    DSVERIFICACAO,
    MSGVERIFICACAO,
    DSCONSULTAVERIFICA,
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU,
    NRORG
) VALUES (
    28,
    2,
    'eSocial - Vínculos com rescisão sem S-2299',
    'eSocial - Vínculos com rescisão sem S-2299',
    'SELECT VM.NRVINCULOM||''-''||VM.NMVINCULOM VINCULO,
       TO_CHAR(VM.DTRESCISAOVINC,''DD/MM/YYYY'') RESCISAO
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = ( SELECT *
                                                  FROM ( SELECT DTMESCOMPETENC
                                                         FROM GPE_VINCULOH
                                                         WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND NRORG      = VH.NRORG
                                                           AND NRVINCULOM = VH.NRVINCULOM
                                                         ORDER BY DTMESCOMPETENC DESC )
                                                   WHERE ROWNUM = 1 )
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND VM.DTRESCISAOVINC BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
   AND (EXISTS (SELECT 1 
                 FROM FPA_ITECALCFOLHA ITC
                 JOIN FPA_CALCULOFOLHA CFL ON CFL.NRORG = ITC.NRORG
                                          AND CFL.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                          AND CFL.NRTIPOMOVIMENT = 1
                                          AND CFL.NRTPMODALIDCAL = 1
            LEFT JOIN ESO_PARAMETRO ESOPARAMS ON ESOPARAMS.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                             AND ESOPARAMS.NRORG = VH.NRORG 
                WHERE ITC.NRVINCULOM = VH.NRVINCULOM
                  AND ITC.NRORG = VH.NRORG
                  AND ITC.NREVENTOM = 3050
                  AND CFL.DTOCORRENCIA = (SELECT MAX(CF.DTOCORRENCIA)
                                            FROM FPA_ITECALCFOLHA IT
                                            JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                                                                    AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                                                                    AND CF.NRTIPOMOVIMENT = 1
                                                                    AND CF.NRTPMODALIDCAL = 1
                                           WHERE IT.NRORG      = ITC.NRORG
                                             AND IT.NRVINCULOM = ITC.NRVINCULOM
                                             AND IT.NREVENTOM = 3050
                                             AND IT.DTOCORRENCIA <= ADD_MONTHS(LAST_DAY(VM.DTRESCISAOVINC),1))))
   AND NOT EXISTS (SELECT 1 
                     FROM ESO_NAOPERIODICO NP
                    WHERE NP.NRORG = VM.NRORG
                      AND NP.NRVINCULOM = VM.NRVINCULOM
                      AND TRUNC(NP.DTMESCOMPETENC,''MM'') = TRUNC(VM.DTRESCISAOVINC,''MM'')
                      AND NP.NRTPAMBIENTE = 1
                      AND NP.NMEVENTO = ''S-2299''
                      AND NP.IDSTATUS IN (''M'',''C'',''A'')
                      AND NP.IDATIVO = ''S''
                      AND NP.NRENVIOEXCL IS NULL)
   AND VM.NRTIPOVINCULOM = 1',
    'S',
    1,
    sysdate,
    1,
    1,
    sysdate,
    1,
    0
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    28,     
    'P_NRORG',   
    '@\FPA::getNrorgTrabalho()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getNrorgTrabalho()@'
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    28,     
    'P_DTMESCOMPETENC',   
    '@\FPA::getDtCompetencia()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getDtCompetencia()@'
)
/

/************************************************************************************************/
/*Vínculos com S-2299 e líquido de rescisão alterado após o envio*/  
INSERT INTO GER_VERIFICACAO (
    NRVERIFICACAO,
    NRTIPOVERIFICA,
    DSVERIFICACAO,
    MSGVERIFICACAO,
    DSCONSULTAVERIFICA,
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU,
    NRORG
) VALUES (
    29,
    2,
    'eSocial - Vínculos com S-2299 e líquido de rescisão alterado após o envio',
    'eSocial - Vínculos com S-2299 e líquido de rescisão alterado após o envio',
    'SELECT
    VM.NRVINCULOM||''-''||VM.NMVINCULOM VINCULO, TO_CHAR(VM.DTRESCISAOVINC,''DD/MM/YYYY'') RESCISAO, NP.DTENVIO DATA_S2299, IC.DTULTATU DATA_LIQUIDO_RESC, CF.NRCALCULOFOLHA CALCULO, CF.NROCORRECAL OCORRENCIA
  FROM ESO_NAOPERIODICO NP
  JOIN GPE_VINCULOM VM ON VM.NRORG = NP.NRORG
                      AND VM.NRVINCULOM = NP.NRVINCULOM
  JOIN FPA_ITECALCFOLHA IC ON IC.NRORG = NP.NRORG
                          AND IC.NRVINCULOM = NP.NRVINCULOM
                          AND IC.NREVENTOM = 3050
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IC.NRORG
                          AND CF.NRCALCULOFOLHA = IC.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT = 1
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
 WHERE NP.NRORG = :P_NRORG
   AND NP.NMEVENTO = ''S-2299''
   AND TRUNC(NP.DTMESCOMPETENC,''MM'') = :P_DTMESCOMPETENC
   AND NP.IDSTATUS IN (''M'',''C'',''A'')
   AND NP.IDATIVO = ''S''
   AND NP.NRENVIOEXCL IS NULL
   AND NP.DTENVIO < IC.DTULTATU',
    'S',
    1,
    sysdate,
    1,
    1,
    sysdate,
    1,
    0
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    29,     
    'P_NRORG',   
    '@\FPA::getNrorgTrabalho()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getNrorgTrabalho()@'
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    29,     
    'P_DTMESCOMPETENC',   
    '@\FPA::getDtCompetencia()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getDtCompetencia()@'
)
/

/************************************************************************************************/
/*Vínculos admitidos na competencia com líquido e sem S2200*/  
INSERT INTO GER_VERIFICACAO (
    NRVERIFICACAO,
    NRTIPOVERIFICA,
    DSVERIFICACAO,
    MSGVERIFICACAO,
    DSCONSULTAVERIFICA,
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU,
    NRORG
) VALUES (
    30,
    2,
    'eSocial - Vínculos admitidos na competencia com líquido e sem S2200',
    'eSocial - Vínculos admitidos na competencia com líquido e sem S2200',
    'SELECT
  VM.NRVINCULOM||''-''||VM.NMVINCULOM VINCULO,
  TO_CHAR(VM.DTADMISSAOVINC,''DD/MM/YYYY'') ADMISSAO
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
                    AND VH.DTMESCOMPETENC = ( SELECT *
                                              FROM ( SELECT DTMESCOMPETENC
                                                     FROM GPE_VINCULOH
                                                     WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND NRORG      = VH.NRORG
                                                       AND NRVINCULOM = VH.NRVINCULOM
                                                     ORDER BY DTMESCOMPETENC DESC )
                                               WHERE ROWNUM = 1 )
JOIN ESO_PARAMETRO EP ON EP.NRORG = VH.NRORG
                    AND EP.NRESTRUTURAM = VH.NRESTRUTLEGAL
/*CÁLCULO DE FOLHA*/
JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG       = VM.NRORG
                         AND ICF.NRVINCULOM  = VM.NRVINCULOM
                         AND ICF.NREVENTOM IN (3030,3050)
JOIN FPA_CALCULOFOLHA CF ON CF.NRORG            = ICF.NRORG
                        AND CF.NRCALCULOFOLHA   = ICF.NRCALCULOFOLHA
                        AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                        AND CF.NRTPMODALIDCAL = 1
                        AND CF.DTOCORRENCIA   = :P_DTMESCOMPETENC
/**/
WHERE VM.NRORG = :P_NRORG
  AND ( VM.DTADMISSAOVINC BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC) )
  AND ( VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC OR VM.DTRESCISAOVINC IS NULL )
  AND NOT EXISTS(SELECT NP.NRENVIO, NP.NRTPAMBIENTE, NP.NRCHAVE
                 FROM ESO_NAOPERIODICO NP
                WHERE NP.NRORG = VM.NRORG
                  AND NP.NRVINCULOM = VM.NRVINCULOM
                  AND NP.NRTPAMBIENTE = EP.NRTPAMBIENTE
                  AND NP.NMEVENTO = ''S-2200''
                  AND NP.IDSTATUS IN (''C'',''A'')
                  AND NP.IDATIVO = ''S'' AND NP.NRENVIOEXCL IS NULL)',
    'S',
    1,
    sysdate,
    1,
    1,
    sysdate,
    1,
    0
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    30,     
    'P_NRORG',   
    '@\FPA::getNrorgTrabalho()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getNrorgTrabalho()@'
)
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    30,     
    'P_DTMESCOMPETENC',   
    '@\FPA::getDtCompetencia()@',            
    'S',                    
    1, 
    SYSDATE,                 
    1,             
    1,
    SYSDATE,                   
    1,               
    0,
    '@\HCM\Util\FPA::getDtCompetencia()@'
)
/

/************************************************************************************************/
UPDATE GER_VERIFICACAO SET DSCONSULTAVERIFICAAUX = DSCONSULTAVERIFICA WHERE NRVERIFICACAO IN (27,28,29,30)
/