DROP TABLE GPE_INFOPROCTRAB;
DROP TABLE GPE_PROCESSTRAB;

CREATE TABLE GPE_PROCESSTRAB
(
	NRORG			NUMBER			NOT NULL, 
	NRPROCESSTRAB	NUMBER			NOT NULL,
	NRESTRUTURAM	NUMBER			NOT NULL,
	NRTPPROCESSTRAB NUMBER			NOT NULL, 
	CDPROCESSTRAB	VARCHAR2(50)	NOT NULL, 
	DTPERPGTO		DATE			NOT NULL, 
	NRPARCNEGOCIO	NUMBER, 
	DTSETENCA		DATE, 
	SGUFVARAPROTRAB VARCHAR2(2), 
	CDMUNIVARPRTRAB VARCHAR2(7), 
	CDVARAPROCETRAB VARCHAR2(10), 
	DTCCP			DATE, 
	NRTPCCP 		NUMBER, 
	CDCNPJCCP		VARCHAR2(14), 
	DSOBSERVACAO	VARCHAR2(500), 
	IDATIVO 		VARCHAR2(1)
		CONSTRAINT CKC_IDATIVO_PROCTRAB CHECK (IDATIVO IN ('S','N')), 
	DTINCLUSAO		DATE			DEFAULT SYSDATE NOT NULL, 
	DTULTATU		DATE, 
	NRORGINCLUSAO	NUMBER			DEFAULT 1, 
	CDOPERINCLUSAO	VARCHAR2(12)	DEFAULT '1', 
	NRORGULTATU 	NUMBER			DEFAULT 1, 
	CDOPERULTATU	VARCHAR2(12)	DEFAULT '1', 
	CONSTRAINT PK_GPE_PROCESSTRAB PRIMARY KEY (NRORG, NRPROCESSTRAB),
	CONSTRAINT FK_PROCTRAB_ESTRU FOREIGN KEY (NRORG, NRESTRUTURAM)
		REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM),
	CONSTRAINT FK_PROCTRAB_PARC FOREIGN KEY (NRORG, NRPARCNEGOCIO)
		REFERENCES PARCNEGOCIO (NRORG, NRPARCNEGOCIO)
);

CREATE TABLE GPE_INFOPROCTRAB
(
	NRORG			NUMBER			NOT NULL, 
	NRINFOPROCTRAB	NUMBER			NOT NULL,
	NRPROCESSTRAB	NUMBER			NOT NULL,
	NRVINCULOM		NUMBER			NOT NULL, 
	NRTPCONTRPROC   NUMBER			NOT NULL, 
	IDREINT 		VARCHAR2(1)
		CONSTRAINT CKC_IDREINT_INFPROTRA CHECK (IDREINT IN ('S','N')), 
	IDCATEG 		VARCHAR2(1)
		CONSTRAINT CKC_IDCATEG_INFPROTRA CHECK (IDCATEG IN ('S','N')), 
	IDNATATIV 		VARCHAR2(1)
		CONSTRAINT CKC_IDNATATIV_INFPROTRA CHECK (IDNATATIV IN ('S','N')), 
	IDMOTDESLIG 	VARCHAR2(1)
		CONSTRAINT CKC_IDMOTDESLIG_INFPROTRA CHECK (IDMOTDESLIG IN ('S','N')), 
	DTMESCOMPINI	DATE			NOT NULL,
	DTMESCOMPFIM	DATE			NOT NULL, 
	NRREPERC		VARCHAR2(1), 
	IDINDENSD	 	VARCHAR2(1)
		CONSTRAINT CKC_IDINDENSD_INFPROTRA CHECK (IDINDENSD IN ('S','N')), 
	IDINDENABONO 	VARCHAR2(1)
		CONSTRAINT CKC_IDINDENABONO_INFPROTRA CHECK (IDINDENABONO IN ('S','N')), 
	IDATIVO 		VARCHAR2(1)
		CONSTRAINT CKC_IDATIVO_INFPROTRA CHECK (IDATIVO IN ('S','N')), 
	DTINCLUSAO		DATE DEFAULT SYSDATE NOT NULL, 
	DTULTATU		DATE, 
	NRORGINCLUSAO	NUMBER DEFAULT 1, 
	CDOPERINCLUSAO	VARCHAR2(12) DEFAULT '1', 
	NRORGULTATU 	NUMBER DEFAULT 1, 
	CDOPERULTATU	VARCHAR2(12) DEFAULT '1', 
	CONSTRAINT PK_GPE_INFOPROCTRAB PRIMARY KEY (NRORG, NRINFOPROCTRAB),
	CONSTRAINT FK_INFPROTRA_PROCTRAB FOREIGN KEY (NRORG, NRPROCESSTRAB)
		REFERENCES GPE_PROCESSTRAB (NRORG, NRPROCESSTRAB),
	CONSTRAINT FK_INFPROTRA_VINC FOREIGN KEY (NRORG, NRVINCULOM)
		REFERENCES GPE_VINCULOM (NRORG, NRVINCULOM)
);

/*
CREATE TABLE GPE_INFOPROCTRABLANC
(
	NRORG				NUMBER		NOT NULL, 
	NRINFOPROCTRABVAL	NUMBER		NOT NULL,
	NRINFOPROCTRAB		NUMBER		NOT NULL,
	DTMESCOMPETENC		DATE		NOT NULL,
	VRBCCPMENSAL		FLOAT		NULL,
	VRBCCP13			FLOAT		NULL,
	VRBCFGTSPROCTRAB	FLOAT		NULL,
	VRBCFGTSSEFIP		FLOAT		NULL,
	VRBCFGTSDECANT		FLOAT		NULL,
	VRBCCPREV			FLOAT		NULL,
	CDCATEG				VARCHAR2(3) NULL,
	VRBCCPREV			FLOAT		NULL,
	IDATIVO 		VARCHAR2(1), 
	DTINCLUSAO		DATE DEFAULT SYSDATE NOT NULL, 
	DTULTATU		DATE, 
	NRORGINCLUSAO	NUMBER DEFAULT 1, 
	CDOPERINCLUSAO	VARCHAR2(12) DEFAULT '1', 
	NRORGULTATU 	NUMBER DEFAULT 1, 
	CDOPERULTATU	VARCHAR2(12) DEFAULT '1', 
	CONSTRAINT CKC_IDATIVO_GPE_PROCESSTRAB CHECK (IDATIVO IN ('S','N')), 
	CONSTRAINT PK_GPE_PROCESSTRAB PRIMARY KEY (NRORG, NRPROCESSTRAB)
);
*/


-- ============================================================
-- Table: FPA_TIPOMOVIMENT
-- ============================================================
INSERT INTO FPA_TIPOMOVIMENT (NRTIPOMOVIMENT, NMTIPOMOVIMENT, IDATIVO, NRORG, DTINCLUSAO) VALUES (100, 'PROCESSO TRABALHISTA', 'S', 0, SYSDATE);


-- ============================================================
-- Table: FPA_EVENTOM
-- ============================================================
INSERT INTO FPA_EVENTOM (NREVENTOM,DTINIVIGENCIA,DTFIMVIGENCIA,NRORG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTIPOEVENTO)
    VALUES ('4500','01/01/2000',null,'0','01/01/2000','01/01/2000','1','1','1','1','TOTAL');

INSERT INTO FPA_EVENTOM (NREVENTOM,DTINIVIGENCIA,DTFIMVIGENCIA,NRORG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTIPOEVENTO)
    VALUES ('4505','01/01/2000',null,'0','01/01/2000','01/01/2000','1','1','1','1','TOTAL');

INSERT INTO FPA_EVENTOM (NREVENTOM,DTINIVIGENCIA,DTFIMVIGENCIA,NRORG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTIPOEVENTO)
    VALUES ('4510','01/01/2000',null,'0','01/01/2000','01/01/2000','1','1','1','1','TOTAL');

INSERT INTO FPA_EVENTOM (NREVENTOM,DTINIVIGENCIA,DTFIMVIGENCIA,NRORG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTIPOEVENTO)
    VALUES ('4515','01/01/2000',null,'0','01/01/2000','01/01/2000','1','1','1','1','TOTAL');

INSERT INTO FPA_EVENTOM (NREVENTOM,DTINIVIGENCIA,DTFIMVIGENCIA,NRORG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTIPOEVENTO)
    VALUES ('4520','01/01/2000',null,'0','01/01/2000','01/01/2000','1','1','1','1','TOTAL');

INSERT INTO FPA_EVENTOM (NREVENTOM,DTINIVIGENCIA,DTFIMVIGENCIA,NRORG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,IDTIPOEVENTO)
    VALUES ('4525','01/01/2000',null,'0','01/01/2000','01/01/2000','1','1','1','1','TOTAL');

-- ============================================================
-- Table: FPA_EVENTOH
-- ============================================================
INSERT INTO FPA_EVENTOH (NREVENTOH,NREVENTOM,NREVENTOTRANSF,NREVENTOESTORNO,NREVENTORESCIS,DTMESCOMPETENC,IDIMPRESSEVENTO,NRORDIMPRESEVEN,VRPELIMITEVENTO,VRLIMITEEVENTO,IDTIPOOCORREVEN,IDUNIDREFEREVEN,QTLIMIREFEREVEN,IDEVENTODEMONST,IDRETROCEDEVENT,IDZERAEVENFECHA,CDINTEGRAEVENTO,IDMEDIAEVENFERI,QTMINOCORMEDFER,QTMINOCORCONSEC,IDFALTASFERIAS,IDFALTAS13RESC,NRPRIORESTORNO,IDPROCDIFRESCIS,IDPROCDIFMOVANT,NREVENTONEG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,NMEVENTOH,IDGERAVRZERO,IDMEDIAVALREF,IDDTOCORRENCIA,NRDIGARREDONDA,VRLIMITEARRED,IDTIPOARREDONDA,DSOBSERVACAO,NRHOMOLOGRUBRICA,VRPERCENTUALEVENTO,NRORG,VRPISOEVENTO,VRTETOEVENTO,NRNATURUBR,NRINCIDCP,NRINCIDIRRF,NRINCIDFGTS,NRINCIDSIND,IDREPDSR,IDREPDECTERC,IDREPFERIAS,IDREPRECISAO,IDRETROCEDEPROV,IDATIVO)
    VALUES ((SELECT MAX(NREVENTOH)+1 FROM FPA_EVENTOH),'4500',null,null,null,'01/01/2000','S','4500',null,null,'SISTEMA',' ',null,'S','SEMPRE','N',null,'N',null,null,'NENHUM','N',null,'N','N',null,'01/01/2000','01/01/2000','1','1','1','1','Base INSS Mensal - Processo Trabalhista','S','REFERENCIA','PAGAMENTO','-2','5','TOTAL',null,null,null,'0','0','0',null,null,null,null,null,'N','N','N','N','N','S');

INSERT INTO FPA_EVENTOH (NREVENTOH,NREVENTOM,NREVENTOTRANSF,NREVENTOESTORNO,NREVENTORESCIS,DTMESCOMPETENC,IDIMPRESSEVENTO,NRORDIMPRESEVEN,VRPELIMITEVENTO,VRLIMITEEVENTO,IDTIPOOCORREVEN,IDUNIDREFEREVEN,QTLIMIREFEREVEN,IDEVENTODEMONST,IDRETROCEDEVENT,IDZERAEVENFECHA,CDINTEGRAEVENTO,IDMEDIAEVENFERI,QTMINOCORMEDFER,QTMINOCORCONSEC,IDFALTASFERIAS,IDFALTAS13RESC,NRPRIORESTORNO,IDPROCDIFRESCIS,IDPROCDIFMOVANT,NREVENTONEG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,NMEVENTOH,IDGERAVRZERO,IDMEDIAVALREF,IDDTOCORRENCIA,NRDIGARREDONDA,VRLIMITEARRED,IDTIPOARREDONDA,DSOBSERVACAO,NRHOMOLOGRUBRICA,VRPERCENTUALEVENTO,NRORG,VRPISOEVENTO,VRTETOEVENTO,NRNATURUBR,NRINCIDCP,NRINCIDIRRF,NRINCIDFGTS,NRINCIDSIND,IDREPDSR,IDREPDECTERC,IDREPFERIAS,IDREPRECISAO,IDRETROCEDEPROV,IDATIVO)
    VALUES ((SELECT MAX(NREVENTOH)+1 FROM FPA_EVENTOH),'4505',null,null,null,'01/01/2000','S','4505',null,null,'SISTEMA',' ',null,'S','SEMPRE','N',null,'N',null,null,'NENHUM','N',null,'N','N',null,'01/01/2000','01/01/2000','1','1','1','1','Base INSS 13 Salario - Processo Trabalhista','S','REFERENCIA','PAGAMENTO','-2','5','TOTAL',null,null,null,'0','0','0',null,null,null,null,null,'N','N','N','N','N','S');

INSERT INTO FPA_EVENTOH (NREVENTOH,NREVENTOM,NREVENTOTRANSF,NREVENTOESTORNO,NREVENTORESCIS,DTMESCOMPETENC,IDIMPRESSEVENTO,NRORDIMPRESEVEN,VRPELIMITEVENTO,VRLIMITEEVENTO,IDTIPOOCORREVEN,IDUNIDREFEREVEN,QTLIMIREFEREVEN,IDEVENTODEMONST,IDRETROCEDEVENT,IDZERAEVENFECHA,CDINTEGRAEVENTO,IDMEDIAEVENFERI,QTMINOCORMEDFER,QTMINOCORCONSEC,IDFALTASFERIAS,IDFALTAS13RESC,NRPRIORESTORNO,IDPROCDIFRESCIS,IDPROCDIFMOVANT,NREVENTONEG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,NMEVENTOH,IDGERAVRZERO,IDMEDIAVALREF,IDDTOCORRENCIA,NRDIGARREDONDA,VRLIMITEARRED,IDTIPOARREDONDA,DSOBSERVACAO,NRHOMOLOGRUBRICA,VRPERCENTUALEVENTO,NRORG,VRPISOEVENTO,VRTETOEVENTO,NRNATURUBR,NRINCIDCP,NRINCIDIRRF,NRINCIDFGTS,NRINCIDSIND,IDREPDSR,IDREPDECTERC,IDREPFERIAS,IDREPRECISAO,IDRETROCEDEPROV,IDATIVO)
    VALUES ((SELECT MAX(NREVENTOH)+1 FROM FPA_EVENTOH),'4510',null,null,null,'01/01/2000','S','4510',null,null,'SISTEMA',' ',null,'S','SEMPRE','N',null,'N',null,null,'NENHUM','N',null,'N','N',null,'01/01/2000','01/01/2000','1','1','1','1','Base FGTS - Processo Trabalhista','S','REFERENCIA','PAGAMENTO','-2','5','TOTAL',null,null,null,'0','0','0',null,null,null,null,null,'N','N','N','N','N','S');

INSERT INTO FPA_EVENTOH (NREVENTOH,NREVENTOM,NREVENTOTRANSF,NREVENTOESTORNO,NREVENTORESCIS,DTMESCOMPETENC,IDIMPRESSEVENTO,NRORDIMPRESEVEN,VRPELIMITEVENTO,VRLIMITEEVENTO,IDTIPOOCORREVEN,IDUNIDREFEREVEN,QTLIMIREFEREVEN,IDEVENTODEMONST,IDRETROCEDEVENT,IDZERAEVENFECHA,CDINTEGRAEVENTO,IDMEDIAEVENFERI,QTMINOCORMEDFER,QTMINOCORCONSEC,IDFALTASFERIAS,IDFALTAS13RESC,NRPRIORESTORNO,IDPROCDIFRESCIS,IDPROCDIFMOVANT,NREVENTONEG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,NMEVENTOH,IDGERAVRZERO,IDMEDIAVALREF,IDDTOCORRENCIA,NRDIGARREDONDA,VRLIMITEARRED,IDTIPOARREDONDA,DSOBSERVACAO,NRHOMOLOGRUBRICA,VRPERCENTUALEVENTO,NRORG,VRPISOEVENTO,VRTETOEVENTO,NRNATURUBR,NRINCIDCP,NRINCIDIRRF,NRINCIDFGTS,NRINCIDSIND,IDREPDSR,IDREPDECTERC,IDREPFERIAS,IDREPRECISAO,IDRETROCEDEPROV,IDATIVO)
    VALUES ((SELECT MAX(NREVENTOH)+1 FROM FPA_EVENTOH),'4515',null,null,null,'01/01/2000','S','4515',null,null,'SISTEMA',' ',null,'S','SEMPRE','N',null,'N',null,null,'NENHUM','N',null,'N','N',null,'01/01/2000','01/01/2000','1','1','1','1','Base FGTS SEFIP - Processo Trabalhista','S','REFERENCIA','PAGAMENTO','-2','5','TOTAL',null,null,null,'0','0','0',null,null,null,null,null,'N','N','N','N','N','S');

INSERT INTO FPA_EVENTOH (NREVENTOH,NREVENTOM,NREVENTOTRANSF,NREVENTOESTORNO,NREVENTORESCIS,DTMESCOMPETENC,IDIMPRESSEVENTO,NRORDIMPRESEVEN,VRPELIMITEVENTO,VRLIMITEEVENTO,IDTIPOOCORREVEN,IDUNIDREFEREVEN,QTLIMIREFEREVEN,IDEVENTODEMONST,IDRETROCEDEVENT,IDZERAEVENFECHA,CDINTEGRAEVENTO,IDMEDIAEVENFERI,QTMINOCORMEDFER,QTMINOCORCONSEC,IDFALTASFERIAS,IDFALTAS13RESC,NRPRIORESTORNO,IDPROCDIFRESCIS,IDPROCDIFMOVANT,NREVENTONEG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,NMEVENTOH,IDGERAVRZERO,IDMEDIAVALREF,IDDTOCORRENCIA,NRDIGARREDONDA,VRLIMITEARRED,IDTIPOARREDONDA,DSOBSERVACAO,NRHOMOLOGRUBRICA,VRPERCENTUALEVENTO,NRORG,VRPISOEVENTO,VRTETOEVENTO,NRNATURUBR,NRINCIDCP,NRINCIDIRRF,NRINCIDFGTS,NRINCIDSIND,IDREPDSR,IDREPDECTERC,IDREPFERIAS,IDREPRECISAO,IDRETROCEDEPROV,IDATIVO)
    VALUES ((SELECT MAX(NREVENTOH)+1 FROM FPA_EVENTOH),'4520',null,null,null,'01/01/2000','S','4520',null,null,'SISTEMA',' ',null,'S','SEMPRE','N',null,'N',null,null,'NENHUM','N',null,'N','N',null,'01/01/2000','01/01/2000','1','1','1','1','Base FGTS Declarada Ant. - Processo Trabalhista','S','REFERENCIA','PAGAMENTO','-2','5','TOTAL',null,null,null,'0','0','0',null,null,null,null,null,'N','N','N','N','N','S');

INSERT INTO FPA_EVENTOH (NREVENTOH,NREVENTOM,NREVENTOTRANSF,NREVENTOESTORNO,NREVENTORESCIS,DTMESCOMPETENC,IDIMPRESSEVENTO,NRORDIMPRESEVEN,VRPELIMITEVENTO,VRLIMITEEVENTO,IDTIPOOCORREVEN,IDUNIDREFEREVEN,QTLIMIREFEREVEN,IDEVENTODEMONST,IDRETROCEDEVENT,IDZERAEVENFECHA,CDINTEGRAEVENTO,IDMEDIAEVENFERI,QTMINOCORMEDFER,QTMINOCORCONSEC,IDFALTASFERIAS,IDFALTAS13RESC,NRPRIORESTORNO,IDPROCDIFRESCIS,IDPROCDIFMOVANT,NREVENTONEG,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,NMEVENTOH,IDGERAVRZERO,IDMEDIAVALREF,IDDTOCORRENCIA,NRDIGARREDONDA,VRLIMITEARRED,IDTIPOARREDONDA,DSOBSERVACAO,NRHOMOLOGRUBRICA,VRPERCENTUALEVENTO,NRORG,VRPISOEVENTO,VRTETOEVENTO,NRNATURUBR,NRINCIDCP,NRINCIDIRRF,NRINCIDFGTS,NRINCIDSIND,IDREPDSR,IDREPDECTERC,IDREPFERIAS,IDREPRECISAO,IDRETROCEDEPROV,IDATIVO)
    VALUES ((SELECT MAX(NREVENTOH)+1 FROM FPA_EVENTOH),'4525',null,null,null,'01/01/2000','S','4525',null,null,'SISTEMA',' ',null,'S','SEMPRE','N',null,'N',null,null,'NENHUM','N',null,'N','N',null,'01/01/2000','01/01/2000','1','1','1','1','Base INSS Declarada Ant. - Processo Trabalhista','S','REFERENCIA','PAGAMENTO','-2','5','TOTAL',null,null,null,'0','0','0',null,null,null,null,null,'N','N','N','N','N','S');

-- ============================================================
-- Table: FPA_TIPOASSOCEVE
-- ============================================================
INSERT INTO FPA_TIPOASSOCEVE (NRTIPOASSOCEVE,NMTIPOASSOCEVE,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO,IDTIPOEVENTO,DSALTERNATIVA,NRORG)
    VALUES ('4500','BASE_INSS_PROCTRAB','S','01/01/2000','01/01/2000','1','1','1','1','Base INSS Mensal - Processo Trabalhista','TOTAL','BASE_INSS_PROCTRAB','9999999999');

INSERT INTO FPA_TIPOASSOCEVE (NRTIPOASSOCEVE,NMTIPOASSOCEVE,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO,IDTIPOEVENTO,DSALTERNATIVA,NRORG)
    VALUES ('4505','BASE_INSS13_PROCTRAB','S','01/01/2000','01/01/2000','1','1','1','1','Base INSS 13 Salario - Processo Trabalhista','TOTAL','BASE_INSS13_PROCTRAB','9999999999');

INSERT INTO FPA_TIPOASSOCEVE (NRTIPOASSOCEVE,NMTIPOASSOCEVE,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO,IDTIPOEVENTO,DSALTERNATIVA,NRORG)
    VALUES ('4510','BASE_FGTS_PROCTRAB','S','01/01/2000','01/01/2000','1','1','1','1','Base FGTS - Processo Trabalhista','TOTAL','BASE_FGTS_PROCTRAB','9999999999');

INSERT INTO FPA_TIPOASSOCEVE (NRTIPOASSOCEVE,NMTIPOASSOCEVE,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO,IDTIPOEVENTO,DSALTERNATIVA,NRORG)
    VALUES ('4515','BASE_FGTS_SEFIP_PROCTRAB','S','01/01/2000','01/01/2000','1','1','1','1','Base FGTS SEFIP - Processo Trabalhista','TOTAL','BASE_FGTS_SEFIP_PROCTRAB','9999999999');

INSERT INTO FPA_TIPOASSOCEVE (NRTIPOASSOCEVE,NMTIPOASSOCEVE,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO,IDTIPOEVENTO,DSALTERNATIVA,NRORG)
    VALUES ('4520','BASE_FGTS_DECANT_PROCTRAB','S','01/01/2000','01/01/2000','1','1','1','1','Base FGTS Declarada Ant. - Processo Trabalhista','TOTAL','BASE_FGTS_DECANT_PROCTRAB','9999999999');

INSERT INTO FPA_TIPOASSOCEVE (NRTIPOASSOCEVE,NMTIPOASSOCEVE,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO,IDTIPOEVENTO,DSALTERNATIVA,NRORG)
    VALUES ('4525','BASE_INSS_DECANT_PROCTRAB','S','01/01/2000','01/01/2000','1','1','1','1','Base INSS Declarada Ant. - Processo Trabalhista','TOTAL','BASE_INSS_DECANT_PROCTRAB','9999999999');

-- ============================================================
-- Table: FPA_ASSOCEVENTO
-- ============================================================
INSERT INTO FPA_ASSOCEVENTO (NRASSOCEVENTO,NREVENTOM,NRTIPOASSOCEVE,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO)
    VALUES ('4500','4500','4500','0','S','01/01/2000','01/01/2000','1','1','1','1','Base INSS Mensal - Processo Trabalhista');

INSERT INTO FPA_ASSOCEVENTO (NRASSOCEVENTO,NREVENTOM,NRTIPOASSOCEVE,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO)
    VALUES ('4505','4505','4505','0','S','01/01/2000','01/01/2000','1','1','1','1','Base INSS 13 Salario - Processo Trabalhista');

INSERT INTO FPA_ASSOCEVENTO (NRASSOCEVENTO,NREVENTOM,NRTIPOASSOCEVE,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO)
    VALUES ('4510','4510','4510','0','S','01/01/2000','01/01/2000','1','1','1','1','Base FGTS - Processo Trabalhista');

INSERT INTO FPA_ASSOCEVENTO (NRASSOCEVENTO,NREVENTOM,NRTIPOASSOCEVE,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO)
    VALUES ('4515','4515','4515','0','S','01/01/2000','01/01/2000','1','1','1','1','Base FGTS SEFIP - Processo Trabalhista');

INSERT INTO FPA_ASSOCEVENTO (NRASSOCEVENTO,NREVENTOM,NRTIPOASSOCEVE,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO)
    VALUES ('4520','4520','4520','0','S','01/01/2000','01/01/2000','1','1','1','1','Base FGTS Declarada Ant. - Processo Trabalhista');

INSERT INTO FPA_ASSOCEVENTO (NRASSOCEVENTO,NREVENTOM,NRTIPOASSOCEVE,NRORG,IDATIVO,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,TXOBSERVACAO)
    VALUES ('4525','4525','4525','0','S','01/01/2000','01/01/2000','1','1','1','1','Base INSS Declarada Ant. - Processo Trabalhista');


-- ============================================================
-- Table: FPA_ASSOCEVENTO
-- ============================================================
UPDATE ESO_EVENTO SET IDATIVO = 'S', IDGRUPO = 'P' WHERE NMEVENTO IN ('S-2500','S-2501');