-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 21.x 
--   Created on:     31/10/2023  12:00                        
--   Issue:          [5] 450925 - Cadastro de responsáveis da estrutura
-- ============================================================
-- Table: SST_RESPMONBIO

CREATE TABLE SST_RESPMONBIO
(
    NRORG                 NUMBER          NOT NULL,
    NRMONBIO              NUMBER          NOT NULL,
    NRPARCMONBIO          NUMBER          NOT NULL,
    NRESTRUTURAM          NUMBER          NOT NULL,
    DTINIRESMONBIO        DATE            NOT NULL,
    DTFIMRESMONBIO        DATE            NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_SST_RESPMONBIO CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,   
    CONSTRAINT PK_NRMONBIO PRIMARY KEY (NRORG, NRMONBIO),
    CONSTRAINT FK_MONBIOPARC FOREIGN KEY(NRORG,NRPARCMONBIO) REFERENCES PARCNEGOCIO (NRORG,NRPARCNEGOCIO),
    CONSTRAINT FK_MONBIONRESTRUT FOREIGN KEY (NRORG, NRESTRUTURAM) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM)
);