-- ============================================================
--   Database name:  FOLHA                                   
--   DBMS name:      ORACLE Version 12.x 
--   Created on:     03/05/2024  11:00                   
--   Issue:          SPRT [20] - 479233 - [HCM] - Conferir novos atributos do cadastro de GHE - Risco

-- ============================================================
-- Table: SST_CLASSNIVELACAO
-- ============================================================

CREATE TABLE SST_CLASSNIVELACAO
(
    NRORG                 NUMBER          NOT NULL,
    NRNIVELACAO           NUMBER          NOT NULL,
    DSNIVELACAO           VARCHAR2(200)       NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_SST_CLASSNIVELACAO CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_SST_NRNIVELACAO PRIMARY KEY (NRNIVELACAO)
);

INSERT INTO SST_CLASSNIVELACAO (NRORG, NRNIVELACAO, DSNIVELACAO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 1, 'Trivial', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSNIVELACAO (NRORG, NRNIVELACAO, DSNIVELACAO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 2, 'Baixo', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSNIVELACAO (NRORG, NRNIVELACAO, DSNIVELACAO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 3, 'Moderado', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSNIVELACAO (NRORG, NRNIVELACAO, DSNIVELACAO, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 4, 'Alto','S', SYSDATE, 0, '1', 1, '1');
COMMIT;
INSERT INTO SST_CLASSNIVELACAO (NRORG, NRNIVELACAO, DSNIVELACAO,IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU) VALUES (
0, 5, 'Muito Alto', 'S', SYSDATE, 0, '1', 1, '1');
COMMIT;