create or replace FUNCTION AJUSTA_DATAS_PROG_EPI
   (P_CRITERIO IN VARCHAR2,
    P_DSINICIO IN SST_FORMPROGEPI.DSINICIO%TYPE,
    P_DSFIM IN SST_FORMPROGEPI.DSFIM%TYPE,
    P_DTINICIAL IN SST_FORMPROGEPI.DTINICIAL%TYPE,
    P_DTFINAL IN SST_FORMPROGEPI.DTFINAL%TYPE,
    P_QTTEMPOMEDIO IN SST_FORMPROGEPI.QTMINATENDMEDIO%TYPE,
    P_QTPESSOASATEND IN SST_FORMPROGEPI.QTATENDENTREPI%TYPE,
    P_TEMPOATEND IN SST_FORMPROGEPI.QTHRDIAENTREPI%TYPE,
    P_DTMESCOMPT IN GPE_VINCULOH.DTMESCOMPETENC%TYPE,
    P_NRORG IN ESTRUTURAH.NRORG%TYPE)
RETURN SST_FORMPROGEPI_DADOS_TABLE PIPELINED
IS
   OUT_RECORD SST_FORMPROGEPI_DADOS_TYPE := SST_FORMPROGEPI_DADOS_TYPE(NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,NULL);

   CURSOR VINCULOS_DADOS_PROGRAMACAO IS
          SELECT FPG.IDPROTECAOEFICAZ AS IDPROTECAOEFICAZ,
                 FPG.NREPI AS NREPI,
                 FPG.NRORG AS NRORG,
                 FPG.QTFORNECIDAEPI AS QTFORNECIDAEPI,
                 FPG.NRVINCULOM AS NRVINCULOM,
                 FPG.DSMODELOEPI AS DSMODELOEPI,
                 FPG.NRCTRLAPROVEPI  AS NRCTRLAPROVEPI,
                 FPG.NRPARCNEGOCIO  AS NRPARCNEGOCIO,
                 FPG.DTENTREGAEPI AS DTENTREGAEPI
            FROM TABLE (SST_FORMPROGEPI_DADOS (P_CRITERIO, P_DSINICIO, P_DSFIM, P_DTINICIAL, P_DTFINAL)) FPG
           ORDER BY FPG.NRVINCULOM , FPG.NREPI;

   V_IDPROTECAOEFICAZ VARCHAR2(01);
   V_NREPI NUMBER;
   V_NRORG NUMBER;
   V_QTFORNECIDAEPI NUMBER;
   V_NRVINCULOM NUMBER;
   V_DSMODELOEPI VARCHAR2(250);
   V_NRCTRLAPROVEPI VARCHAR2(250);
   V_NRPARCNEGOCIO NUMBER;
   V_DTENTREGAEPI DATE;

   V_DTENTREGAEPINOVA DATE;
   V_TEMPOUSADO FLOAT := 0;
   V_TOTALDISPON FLOAT :=0;
   V_NRVINCULOANTES NUMBER := 0;
   V_DTANTERIOR DATE;
   V_VERIFICAVIGENCIA NUMBER;
   V_VERIFICADIAUTIL NUMBER;

BEGIN
   V_DTENTREGAEPINOVA := P_DTINICIAL;
   V_TOTALDISPON := HORACHAR_HORADEC(P_TEMPOATEND) * P_QTPESSOASATEND;

   OPEN VINCULOS_DADOS_PROGRAMACAO;
   LOOP
      FETCH VINCULOS_DADOS_PROGRAMACAO INTO V_IDPROTECAOEFICAZ, V_NREPI, V_NRORG, V_QTFORNECIDAEPI, V_NRVINCULOM, V_DSMODELOEPI, V_NRCTRLAPROVEPI,
                                            V_NRPARCNEGOCIO, V_DTENTREGAEPI;
      EXIT WHEN VINCULOS_DADOS_PROGRAMACAO%NOTFOUND OR (V_TEMPOUSADO = V_TOTALDISPON AND V_DTENTREGAEPINOVA = P_DTFINAL);

         --VERIFICA SE A DATA PROGRAMADA É DIA ÚTIL. CASO NÃO FOR E O VINCULO ATUAL FOR DIFERENTE DO ANTERIOR PASSA PARA A PRÓXIMA DATA.
         BEGIN
            SELECT COUNT(*)
              INTO V_VERIFICADIAUTIL
              FROM OCORCALENDARIO ORC
              JOIN ESTRUTURAH ETH
                ON (ORC.NRCALENDARIO = ETH.NRCALENDARIO
               AND  ORC.NRORG = ETH.NRORG)
              JOIN GPE_VINCULOH VIH
                ON (ETH.NRESTRUTURAM = VIH.NRESTRUTLEGAL)
             WHERE VIH.DTMESCOMPETENC = P_DTMESCOMPT
               AND VIH.NRORG = P_NRORG
               AND VIH.NRVINCULOM = V_NRVINCULOM
               AND ORC.DTCALENDARIO = V_DTENTREGAEPINOVA;

            IF V_VERIFICADIAUTIL <> 0 AND V_NRVINCULOM <> V_NRVINCULOANTES THEN
               V_DTENTREGAEPINOVA := V_DTENTREGAEPINOVA + 1;
            END IF;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTENTREGAEPINOVA := V_DTENTREGAEPINOVA;
         END;

         --VERIFICA SE O TEMPO JÁ UTILIZADO É IGUAL A ZERO.
         IF V_TEMPOUSADO = 0 THEN

            --BUSCA A QUANTIDADE DE ATENDIMENTOS JA PROGRAMADOS PARA A DATA PESQUISADA
            BEGIN
               SELECT (COUNT(*)*P_QTTEMPOMEDIO)/60
                 INTO V_TEMPOUSADO
                 from (SELECT COUNT(*)
                         FROM SST_HISTORICOEPI HIS
                        WHERE HIS.DTENTREGAEPI = V_DTENTREGAEPINOVA
                          AND HIS.NRVINCULOM <> V_NRVINCULOM
                        GROUP BY HIS.NRVINCULOM);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_TEMPOUSADO := NULL;
            END;
         END IF;

         --SE O VINCULO ATUAL FOR DIFERENTE DO ANTERIOR, INCREMENTA O TEMPO USADO.
         IF V_NRVINCULOANTES IS NULL OR V_NRVINCULOANTES <> V_NRVINCULOM THEN
            V_TEMPOUSADO := V_TEMPOUSADO + (P_QTTEMPOMEDIO/60);
         END IF;

         IF V_NRVINCULOM = V_NRVINCULOANTES THEN
            V_DTENTREGAEPI := V_DTANTERIOR;
         ELSE
            V_DTENTREGAEPI := V_DTENTREGAEPINOVA;
            V_DTANTERIOR := V_DTENTREGAEPINOVA;

            --VERIFICA SE O TEMPO UTILIZADO É IGUAL AO DISPONÍVEL OU SE MAIS UM ATENDIMENTO EXTRAPOLA O TEMPO DISPONÍVEL.
            --CASO SEJA VERDADE, SALVA A DATA ANTERIOR; AUMENTA A DATA ATUAL EM 1 E DEFINE O TEMPO USADO PARA A DATA ATUAL COMO 0
            IF V_TEMPOUSADO = V_TOTALDISPON OR (V_TEMPOUSADO + (P_QTTEMPOMEDIO/60)) > V_TOTALDISPON THEN
               V_DTANTERIOR := V_DTENTREGAEPINOVA;
               V_DTENTREGAEPINOVA := V_DTENTREGAEPINOVA + 1;
               V_TEMPOUSADO := 0;
            END IF;
         END IF;

         --VERIFICA SE A DATA PROGRAMADA ESTÁ DENTRO DAS DATAS DE VIGÊNCIA GRAVADAS.
         BEGIN
            SELECT COUNT(*)
              INTO V_VERIFICAVIGENCIA
              FROM (SELECT NRVINCULOM, NRORG, NRPERFILEPI
                      FROM SST_PERFILEPIVINCULO PEV
                     WHERE V_DTENTREGAEPI BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, V_DTENTREGAEPI)
                       AND NRVINCULOM = V_NRVINCULOM) PEV
             INNER JOIN (SELECT NREPI, NRORG, NRPERFILEPI
                           FROM SST_ITEMPERFILEPI
                          WHERE V_DTENTREGAEPI BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, V_DTENTREGAEPI)) IPE
                     ON IPE.NRPERFILEPI = PEV.NRPERFILEPI
                    AND IPE.NRORG       = PEV.NRORG
             WHERE IPE.NREPI = V_NREPI
               AND IPE.NRORG = V_NRORG;
         EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VERIFICAVIGENCIA := 0;
         END;


         IF V_VERIFICAVIGENCIA <> 0 THEN
            --CASO ESTEJA DENTRO DA VIGÊNCIA, É VERIFICADO SE HÁ FORNECEDORES PARA AQUELE EPI. SE HOUVER SOMENTE UM FORNCEDOR, ELE É RETORNADO.CASO
            --CONTRARIO, NENHUM FORNECEDOR É RETORNADO.
            BEGIN
               SELECT DECODE(FEP.QTFORNECED, 1, FEP.DSMODELOEPI, NULL) AS DSMODELOEPI,
                      DECODE(FEP.QTFORNECED, 1, FEP.NRCTRLAPROVEPI, NULL) AS NRCTRLAPROVEPI,
                      DECODE(FEP.QTFORNECED, 1, FEP.NRPARCNEGOCIO, NULL) AS NRPARCNEGOCIO
                 INTO V_DSMODELOEPI, V_NRCTRLAPROVEPI, V_NRPARCNEGOCIO
                 FROM (SELECT MAX(NRPARCNEGOCIO) AS NRPARCNEGOCIO,
                              MAX(NRCTRLAPROVEPI) AS NRCTRLAPROVEPI,
                              MAX(DSMODELOEPI) AS DSMODELOEPI,
                              COUNT(*) AS QTFORNECED
                         FROM SST_FORNECEEPI
                        WHERE V_DTENTREGAEPI BETWEEN DTINIVIGENCIA AND NVL(DTFIMVIGENCIA, V_DTENTREGAEPI)
                          AND NREPI = V_NREPI
                          AND NRORG = V_NRORG) FEP;
            EXCEPTION
              WHEN NO_DATA_FOUND THEN
                  V_DSMODELOEPI := NULL;
                  V_NRCTRLAPROVEPI := NULL;
                  V_NRPARCNEGOCIO := NULL;
            END;



            OUT_RECORD.IDPROTECAOEFICAZ := V_IDPROTECAOEFICAZ;
            OUT_RECORD.NREPI := V_NREPI;
            OUT_RECORD.NRORG := V_NRORG;
            OUT_RECORD.QTFORNECIDAEPI := V_QTFORNECIDAEPI;
            OUT_RECORD.NRVINCULOM := V_NRVINCULOM;
            OUT_RECORD.DSMODELOEPI := V_DSMODELOEPI;
            OUT_RECORD.NRCTRLAPROVEPI := V_NRCTRLAPROVEPI;
            OUT_RECORD.NRPARCNEGOCIO := V_NRPARCNEGOCIO;
            OUT_RECORD.DTENTREGAEPI := V_DTENTREGAEPI;
            PIPE ROW(OUT_RECORD);
         END IF;

         V_NRVINCULOANTES := V_NRVINCULOM;
   END LOOP;
   RETURN;
END;
/