/**-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------**/
/*HISTORICO_RESCISAO
/*
/*
--DROP TABLE HISTORICO_RESCISAO;
--SELECT * FROM HISTORICO_RESCISAO;
/**-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------**/
CREATE TABLE HISTORICO_RESCISAO AS
SELECT
	'01' AS CodEmp,				/* Codigo da Empresa    */
	res.RG_FILIAL,				/* Codigo da Filial     */
	fun.RA_MAT,					/* Matricula Colabodor  */
	fun.RA_CATFUNC,				/* Categoria Interna    */
	fun.RA_CATEFD,				/* Categori E-Social    */
	res.RG_DATADEM,				/* Data de Demissao     */
	res.RG_DATAHOM,				/* Data de Homologacao  */
	res.RG_DTAVISO,				/* Data do Aviso	    */
	res.RG_DTPROAV,				/* Data de Proj Aviso   */			
	res.RG_DTGERAR,				/* Data de Pagamento    */ 
	res.RG_TIPORES,				/* Tipo de Rescisao     */
	res.RG_OBS,					/* Observacao           */
	res.RG_COMPRAV,				/* Comprovou novo emprego (1=Sim | 2= Nao) */
	res.RG_OBITO,				/* Atestado de obito             */
	res.RG_SUCES,				/* CNPJ Empresa Sucessora        */
	fun.RA_RESCRAI,				/* Codigo RAIS - Desligamento    */
	X5.X5_DESCRI,				/* Descricao RAIS - Desligamento */
	res.RG_INDAV,				/* Indicativo de cumprimento do aviso (0=Cump.total; 1=Cump.parc.dev.obt.empr.p/empregado; 2=Cump.parc.por inic. empregador; 3=Outras hip.cump.parc.; 4=Av.PR.ind ou nao ex) */
    res.rg_efetiva                 /* Define se  simulao ou se a resciso  eftiva - EFETIVA='S', SIMULAO='N' */
FROM
	SIGAP12.SRG010 res
	INNER JOIN SIGAP12.SRA010 fun ON res.RG_MAT = fun.RA_MAT AND res.RG_FILIAL = fun.RA_FILIAL 
	LEFT JOIN SIGAP12.SX5010 X5 ON X5.X5_CHAVE = fun.RA_RESCRAI	
    AND X5.X5_FILIAL = res.RG_FILIAL AND X5.X5_TABELA = '27' /* Tabela virtual que contem algumas descricoes, incluindo a da descricao da RAIS  */
	LEFT JOIN SIGAP12.SR2010 rais ON rais.R2_FILIAL = res.RG_FILIAL AND rais.R2_MAT = fun.RA_MAT

WHERE	
	res.rg_efetiva='S'
    AND res.D_E_L_E_T_ <> '*' AND fun.D_E_L_E_T_  <> '*'
	AND res.RG_DATAHOM = (
						SELECT 
							MIN(sub.RG_DATAHOM)
						FROM
							SIGAP12.SRG010 sub
						WHERE	
							sub.RG_FILIAL = res.RG_FILIAL
							AND sub.RG_MAT = res.RG_MAT
							AND sub.D_E_L_E_T_ <> '*')

UNION ALL

SELECT 
	'06' AS CodEmp,				/* Codigo da Empresa    */
	res.RG_FILIAL,				/* Codigo da Filial     */
	fun.RA_MAT,					/* Matricula Colabodor  */
	fun.RA_CATFUNC,				/* Categoria Interna    */
	fun.RA_CATEFD,				/* Categori E-Social    */
	res.RG_DATADEM,				/* Data de Demissao     */
	res.RG_DATAHOM,				/* Data de Homologacao  */
	res.RG_DTAVISO,				/* Data do Aviso	    */
	res.RG_DTPROAV,				/* Data de Proj Aviso   */			
	res.RG_DTGERAR,				/* Data de Pagamento    */ 
	res.RG_TIPORES,				/* Tipo de Rescisao     */
	res.RG_OBS,					/* Observacao           */
	res.RG_COMPRAV,				/* Comprovou novo emprego (1=Sim | 2= Nao) */
	res.RG_OBITO,				/* Atestado de Obito             */
	res.RG_SUCES,				/* CNPJ Empresa Sucessora        */
	fun.RA_RESCRAI,				/* Codigo RAIS - Desligamento    */
	X5.X5_DESCRI,				/* Descricao RAIS - Desligamento */
	res.RG_INDAV,				/* Indicativo de cumprimento do aviso (0=Cump.total; 1=Cump.parc.dev.obt.empr.p/empregado; 2=Cump.parc.por inic. empregador; 3=Outras hip.cump.parc.; 4=Av.PR.ind ou nao ex) */
    res.rg_efetiva                  /* Define se  simulao ou se a resciso  eftiva - EFETIVA='S', SIMULAO='N' */
FROM
	SIGAP12.SRG060 res
	INNER JOIN SIGAP12.SRA060 fun ON res.RG_MAT = fun.RA_MAT AND res.RG_FILIAL = fun.RA_FILIAL 
	INNER JOIN SIGAP12.SX5060 X5 ON X5.X5_CHAVE = fun.RA_RESCRAI 
    AND X5.X5_FILIAL = res.RG_FILIAL AND X5.X5_TABELA = '27' /* Tabela virtual que contem algumas descricoes, incluindo a da descricao da RAIS  */
	LEFT JOIN SIGAP12.SR2060 rais ON rais.R2_FILIAL = res.RG_FILIAL AND rais.R2_MAT = fun.RA_MAT
WHERE	
	res.rg_efetiva='S'
    AND res.D_E_L_E_T_ <> '*' AND fun.D_E_L_E_T_  <> '*'
	AND res.RG_DATAHOM = (
					SELECT 
						MIN(sub.RG_DATAHOM)
					FROM
						SIGAP12.SRG060 sub
					WHERE	
						sub.RG_FILIAL = res.RG_FILIAL
						AND sub.RG_MAT = res.RG_MAT
						AND sub.D_E_L_E_T_ <> '*')



