SELECT 

MAT_SUCESSAO.MATRICULA_LG AS "01_Matricula",                 
EMPRESA_ORIGEM.CODIGO_EMPRESA_LG AS "02_Codigo da Empresa",
TO_CHAR (TO_DATE (TB_AUX_TRANSFERENCIA.RE_DATA, 'YYYYMMDD')-1, 'YYYY/MM/DD') AS "03_Data da ocorrencia",
'' AS "04_Data (Publicacao)",
'' AS "05_Situacao (Publicacao)",
'' AS "06_Data do pagamento",
'40' AS "07_Tipo da rescisao (Rais)",                                 
'11' AS "08_Motivo legal do desligamento", /* Colaborador com vinculo */
'' AS "09_Motivo legal do desligamento", /* Colaborador sem vinculo */
'' AS "10_Codigo (Motivo do desligamento)",
'0' AS "11_Codigo do Saque",
'' AS "12_Inicio do aviso previo",
'' AS "13_Projecao do Aviso previo",
'' AS "14_Processo trabalhista",
'' AS "15_Processo judicial com suspensao",
'' AS "16_Atestado de obito",
'70' AS "17_Codigo (Nova situacao)",  
'5' AS "18_Codigo (Folha de Pagamento)",
'S' AS "19_Homologacao",
'' AS "20_Quitacao",
'' AS "21_Data da Homologacao",
'' AS "22_Informacoes a Caixa",
'' AS "23_Colaborador comprovou ter novo e",
'' AS "24_Efetivar a rescisao e manter pro",
'' AS "25_Em caso de exclusao manter ocorr",
'' AS "26_Transferencia por motivo de suce",
'' AS "27_Preencher dados do empregador su",
TRA.INSCRICAO_LG AS "28_CNPJ",
CASE TRA.INSCRICAO_LG
WHEN '05863041000125' THEN 'SNACKS PRODUTOS ALIMENTICIOS LTDA'
WHEN '24028908000171' THEN 'CARPER INDUSTRIA E COMERCIO DE PRODUTOS ALIMENTICIOS E BEBIDAS LTDA'
WHEN '31803286000177' THEN 'MA DISTRIBUICAO DE ALIMENTOS LTDA'
WHEN '01850985000107' THEN 'TOP SERVICOS INDUSTRIAIS E PUBLICIDADE LTDA'
WHEN '24996245000189' THEN 'IVS TRANSPORTES LTDA'
WHEN '32316307000192' THEN 'DF DISTRIBUICAO DE ALIMENTOS LTDA'
WHEN '01121175000110' THEN 'CICOPAL INDUSTRIA E COMERCIO DE PRODUTOS ALIMENTICIOS E HIGIENE PESSPAL LTDA' 
ELSE '' END AS "29_Razao Social",
'' AS "30_Efetivar rescisao mesmo quando a",
'' AS "31_Efetivar a rescisao somente se o",
'' AS "32_Impedir alteracao do gestor da u",
'' AS "33_Lancar saldo devedor de emprestimos",
'' AS "34_Efetivar a rescisao caso nao exi",
'' AS "35_Exclusao de valores calculados p",
'0' AS "36_Tipo de rescisao",
'' AS "37_Quarentena Trabalhista",
'' AS "38_Data fim da quarentena",
'' AS "39_Aviso previo indenizado",
'' AS "40_Cumprimento do aviso previo",
'' AS "41_Credito Consignado com Garantia de",
'S' AS "42_Mesmo que o colaborador possua o",
'S' AS "43_Mesmo quando a data da rescisao",
'S' AS "44_O colaborador esteja em periodo",
'S' AS "45_E estornar ocorrencias programad",
'' AS "46_Efetivar o estorno da rescisao m",
'S' AS "47_E estornar ocorrencias programad",
'S' AS "48_E estornar ocorrencias programad"

FROM TB_AUX_TRANSFERENCIA


LEFT JOIN TB_AUX_FUNCIONARIOS FUNC_ORIGEM ON FUNC_ORIGEM.RA_FILIAL = RE_FILIALD AND FUNC_ORIGEM.RA_MAT = RE_MATD
LEFT JOIN TB_AUX_FUNCIONARIOS FUNC_DESTINO ON FUNC_DESTINO.RA_FILIAL = RE_FILIALP AND FUNC_DESTINO.RA_MAT = RE_MATP
LEFT JOIN LG_DEPARA_EMPRESA EMPRESA_DESTINO ON TRIM(EMPRESA_DESTINO.M0_CODFIL) = TRIM(RE_FILIALP) 
AND TRIM(EMPRESA_DESTINO.M0_CODIGO) = FUNC_DESTINO.CODEMP
LEFT JOIN LG_DEPARA_EMPRESA EMPRESA_ORIGEM ON TRIM(EMPRESA_ORIGEM.M0_CODFIL) = TRIM(RE_FILIALD)
AND TRIM(EMPRESA_ORIGEM.M0_CODIGO) = FUNC_ORIGEM.CODEMP

LEFT JOIN LG_DEPARA_MATRICULA MAT_SUCESSAO ON TO_NUMBER(MAT_SUCESSAO.FILIAL_PROTHEUS) = 
TO_NUMBER(RE_FILIALD) AND TO_NUMBER(MAT_SUCESSAO.MATRICULA_PROTHEUS) 
= TO_NUMBER(RE_MATD) AND MAT_SUCESSAO.EMPESA_PROTHEUS = FUNC_ORIGEM.CODEMP

LEFT JOIN LG_DEPARA_MATRICULA MAT_FUNC ON 
TO_NUMBER(MAT_FUNC.FILIAL_PROTHEUS) = 
TO_NUMBER(RE_FILIALP) AND TO_NUMBER(MAT_FUNC.MATRICULA_PROTHEUS) = TO_NUMBER(RE_MATP)
AND MAT_FUNC.EMPESA_PROTHEUS = FUNC_DESTINO.CODEMP

LEFT JOIN TB_TRANSFERENCIAS TRA ON TRA.ORIGEM = FUNC_ORIGEM.RA_FILIAL AND TRA.MAT_ORIGEM = FUNC_ORIGEM.RA_MAT

WHERE RE_FILIALD <> RE_FILIALP
AND EMPRESA_ORIGEM.CODIGO_EMPRESA_LG <> EMPRESA_DESTINO.CODIGO_EMPRESA_LG
--AND FUNC_ORIGEM.RA_CIC = '03488606333'

ORDER BY 2,1


