/*
	HISTRICO DE MOVIMENTAES DE CARGOS
	BASE PROTHEUS - CICOPAL
*/
SELECT
    'ENTO'              AS "001 ENTO",
    ROW_NUMBER()
    OVER(
        ORDER BY
            MOV.CODEMP, MOV.R7_FILIAL, MOV.R7_MAT, MOV.R7_DATA
    )                    AS "002 ID",
    'NO'                AS "003 IGNORAR",
  --  MOV.R7_DATA,
    SUBSTR(MOV.R7_DATA,7,2) ||'/' || SUBSTR(MOV.R7_DATA, 5, 2) || '/' || SUBSTR(MOV.R7_DATA,1, 4) AS "004 DATA MOVIMENTAO",
-----------------------------------------------------------------------------------------------
    CASE MOV.CODEMP
             WHEN	'010'		THEN	'1'
            WHEN	'060'		THEN	'6'
    END AS "005 CODIGO DA EMPRESA",
-----------------------------------------------------------------------------------------------
    TO_NUMBER(MOV.R7_MAT)          AS "006 MATRICULA",
-----------------------------------------------------------------------------------------------
    CASE X5_CHAVE
            WHEN	'001'		THEN	'8'
            WHEN	'002'		THEN	'24'
            WHEN	'003'		THEN	'13'
            WHEN	'004'		THEN	'4'
            WHEN	'005'		THEN	'21'
            WHEN	'006'		THEN	'11'
            WHEN	'007'		THEN	'31'
            WHEN	'008'		THEN	'12'
            WHEN	'010'		THEN	'42'
            WHEN	'011'		THEN	'16'
            WHEN	'012'		THEN	'15'
    END AS "007 CODIGO DO MOTIVO DA MOVIMENTAO", 
-----------------------------------------------------------------------------------------------
    X5_DESCRI AS "008 DESCRIO",
     MOV.CODIGONOVOLG        AS "025 CODIGO CARGO EFETIVO DESTINO",
R7_DATA,
RA_ADMISSA    
       
FROM
TB_AUX_MOVIMENTACAO_CARGOS MOV
LEFT JOIN TB_AUX_MOTIVOS_MOVIMENTACAO ON X5_CHAVE = R7_TIPO AND X5_FILIAL = R7_FILIAL
LEFT JOIN TB_AUX_FUNCIONARIOS ON RA_FILIAL = R7_FILIAL AND RA_MAT = R7_MAT 
AND TB_AUX_FUNCIONARIOS.CODEMP||'0' = MOV.CODEMP

/*MOVIMENTACAO ATUAL*/

LEFT JOIN (SELECT R7_FILIAL FILIAL, R7_MAT MAT , R7_DATA DATA_ALT ,R7_TIPO TIPO, R7_FUNCAO CARGO, R7_SEQ SEQ, CODIGONOVOLG CARGOLG,
ROW_NUMBER() OVER (PARTITION BY R7_FILIAL, R7_MAT ORDER BY R7_FILIAL, R7_MAT, R7_DATA,R7_SEQ ASC) SQ

FROM TB_AUX_MOVIMENTACAO_CARGOS) MOV_ATUAL ON MOV_ATUAL.FILIAL = MOV.R7_FILIAL
AND MOV_ATUAL.MAT = MOV.R7_MAT AND MOV_ATUAL.DATA_ALT=MOV.R7_DATA AND MOV_ATUAL.TIPO = MOV.R7_TIPO
AND MOV_ATUAL.SEQ = MOV.R7_SEQ

/*MOVIMENTACAO ANTERIOR*/

LEFT JOIN (SELECT R7_FILIAL FILIAL, R7_MAT MAT , R7_DATA DATA_ALT ,R7_TIPO TIPO, R7_FUNCAO CARGO, R7_SEQ SEQ, CODIGONOVOLG CARGOLG,
ROW_NUMBER() OVER (PARTITION BY R7_FILIAL, R7_MAT ORDER BY R7_FILIAL, R7_MAT, R7_DATA,R7_SEQ ASC) SQ

FROM TB_AUX_MOVIMENTACAO_CARGOS) MOV_ANTERIOR ON MOV_ANTERIOR.FILIAL = MOV.R7_FILIAL
AND MOV_ANTERIOR.MAT = MOV.R7_MAT AND MOV_ANTERIOR.DATA_ALT<=MOV_ATUAL.DATA_ALT  
AND MOV_ANTERIOR.SQ = MOV_ATUAL.SQ-1

WHERE R7_DATA <> RA_ADMISSA and R7_DATA > RA_ADMISSA
--AND  MOV.R7_MAT = '000177'
--AND MOV.R7_FILIAL = 010101
--AND MOV_ANTERIOR.CARGO <> MOV_ATUAL.CARGO
AND MOV_ANTERIOR.CARGOLG <> MOV_ATUAL.CARGOLG


ORDER BY MOV.CODEMP, MOV.R7_FILIAL, MOV.R7_MAT, MOV.R7_DATA, MOV.R7_SEQ




