/**********************************************************************************************************************/
/**** PROJETO GRUPO CICOPAL 2022                                                                                     **/
/**** IMPLANTAÇÃO DOS FUNCIONARIOS                                                                                  **/
/**** SCRITP DE PREPARAÇÃO DA MIGRAÇÃO                                                                               **/
/**** ESSE SCRIPT GERA LAYOUT DA TABELA AUXILIAR (TB_AUX_HISTORIAFASTAMENTO) ATESTADO MEDICO                         **/
/**********************************************************************************************************************/

--------------------------------------------------------
-- GERAÇÃO DO LAYOUT DE ATESTADO MEDICO
--------------------------------------------------------
SELECT 
	--afast.R8_MAT 
     LGM.MATRICULA_LG
     AS "01_Matricula",    
	-----------------------------------------------
	--SUBSTR(afast.R8_FILIAL, 3,2) 
     FN_RETORNA_EMPRESA(afast.R8_FILIAL, afast.CODEMP)
     AS "002 Empresa",
	-----------------------------------------------
    CASE
		WHEN afast.R8_DATAINI IS NOT NULL THEN SUBSTR(afast.R8_DATAINI, 0, 4) || '/' || SUBSTR(afast.R8_DATAINI, 5, 2) || '/' || SUBSTR(afast.R8_DATAINI, 7, 2) 
		ELSE ''
	END AS "003 Data da ocorrencia",
	-----------------------------------------------
	'1' "004 Sequencia",
	-----------------------------------------------
	CASE
		WHEN afast.R8_DATAINI IS NOT NULL THEN SUBSTR(afast.R8_DATAINI, 0, 4) || '/' || SUBSTR(afast.R8_DATAINI, 5, 2) || '/' || SUBSTR(afast.R8_DATAINI, 7, 2) 
		ELSE ''
	END AS  "005 Data inicio",
	-----------------------------------------------
	CASE
         WHEN TRIM(afast.R8_DATAFIM) IS NULL      THEN NULL 
         ELSE TO_CHAR(TO_DATE(afast.R8_DATAFIM, 'yyyymmdd')+1,'yyyy/mm/dd')         
	END  "006 Data de retorno", 
	----------------------------------------------
	CASE 
		WHEN TRIM(afast.R8_DATAFIM) IS NULL THEN 'S'
		ELSE 'N' 
	END AS "007 Sem previsao de retorno",
	-----------------------------------------------
	CASE 
        WHEN TRIM(afast.R8_DATAFIM) IS NULL                     THEN ''
        WHEN RTRIM(afast.R8_DURACAO) = 999 THEN RTRIM(TO_DATE(afast.R8_DATAFIM, 'yyyymmdd') - TO_DATE(afast.R8_DATAINI, 'yyyymmdd')+1)        
        ELSE RTRIM(afast.R8_DURACAO)
	END AS "008 Quantidade de dias", 
	-----------------------------------------------
'' AS "009 Codigo (CID)",
'' AS "010 Nome do Emitente",    /* Valor Padrao */
'' AS "011 Inscricao orgao de Classe",     /* Valor Padrao */
'' AS "012 orgao Emissor",                   /* Valor Padrao */
'' AS "013 Codigo (UF)"                      /* Valor Padrao */
   FROM
TB_AUX_HISTORICOAFASTAMENTO afast

LEFT JOIN LG_DEPARA_MATRICULA LGM
	ON (LGM.FILIAL_PROTHEUS = afast.R8_FILIAL AND LGM.MATRICULA_PROTHEUS = afast.R8_MAT 
    AND LGM.EMPESA_PROTHEUS = afast.CODEMP)
    
    
inner join SIGAP12.RCM010 on RCM_TIPO = AFAST.R8_TIPOAFA and D_E_L_E_T_ <> '*'
WHERE
afast.R8_TIPO NOT IN (
'Q',	--30	AFASTAMENTO TEMPORARIO POR MOTIVO LICENCA GESTANTE     
'O',	--30	AFASTAMENTO TEMPORARIO ACIDENTE TRABALHO SUP. 15 DIAS  
'P' 	--30	AFASTAMENTO TEMPORARIO DOENCA SUPERIOR 15 DIAS
)	-- JA MIGRADOS
AND afast.R8_TIPOAFA NOT IN ('001','017') --FERIAS E APOSENTADORIA

ORDER BY
	afast.CodEmp,
	afast.R8_FILIAL,
	afast.R8_MAT,
	afast.R8_DATAINI
    
    
    
    
    
