CREATE TABLE TB_AUX_FICHA_FERIASRESCISAO AS
SELECT 
	'01' AS "CODEMP",                   -- Empresa/Tabela
	SRR.RR_FILIAL "FILIAL",
	SRR.RR_MAT "MAT",
	SRR.RR_TIPO3,						-- Tipo da ficha (F - Férias | R - Rescisão)
	SRR.RR_PD,                          -- Cod Evento
	SRV.RV_DESC,                        -- Descricao do evento
	SRV.RV_TIPO,                        -- Tipo da Evento (H=Horas;V=Valor;D=Dias)
	SRV.RV_TIPOCOD,						-- Tipo da Evento (1=Provento;2=Desconto;3=Base (Provento);4=Base (Desconto))
	SRR.RR_TIPO2,                       -- Cod Folha
	SRR.RR_ROTEIR,						-- Codigo Roteiro de Cálculo
	SRY.RY_DESC,						-- Descrição Roteiro de Cálculo
SRR.RR_PERIODO AS RR_PERIODO,   -- Referência da última utilização
SRR.RR_VALOR,						-- Valor Acumulado
SRR.RR_HORAS						-- Valor Base

FROM 
	SIGAP12.SRR010 SRR
	INNER JOIN SIGAP12.SRV010 SRV ON SRR.RR_PD = SRV.RV_COD AND  SUBSTR(TRIM(SRR.RR_FILIAL),1,4)= TRIM(SRV.RV_FILIAL)  
    AND SRV.D_E_L_E_T_ <> '*'
	LEFT JOIN SIGAP12.SRY060 SRY ON SRR.RR_ROTEIR = SRY.RY_CALCULO AND SRY.D_E_L_E_T_ <> '*'
WHERE
	SRR.D_E_L_E_T_ <> '*'
	
	
	
UNION ALL

SELECT 
	'06' AS "CODEMP",                   -- Empresa/Tabela
	SRR.RR_FILIAL "FILIAL",
	SRR.RR_MAT "MAT",
	SRR.RR_TIPO3,						-- Tipo da ficha (F - Férias | R - Rescisão)
	SRR.RR_PD,                          -- Cod Evento
	SRV.RV_DESC,                        -- Descricao do evento
	SRV.RV_TIPO,                        -- Tipo da Evento (H=Horas;V=Valor;D=Dias)
	SRV.RV_TIPOCOD,						-- Tipo da Evento (1=Provento;2=Desconto;3=Base (Provento);4=Base (Desconto))
	SRR.RR_TIPO2,                       -- Cod Folha
	SRR.RR_ROTEIR,						-- Codigo Roteiro de Cálculo
SRY.RY_DESC AS RY_DESC,						-- Descrição Roteiro de Cálculo
SRR.RR_PERIODO AS RR_PERIODO,   -- Referência da última utilização
SRR.RR_VALOR,						-- Valor Acumulado
SRR.RR_HORAS						-- Valor Base

FROM 
    SIGAP12.SRR060 SRR
	INNER JOIN SIGAP12.SRV060 SRV ON SRR.RR_PD = SRV.RV_COD AND SUBSTR(TRIM(SRR.RR_FILIAL),1,4)= TRIM(SRV.RV_FILIAL)
    AND SRV.D_E_L_E_T_ <> '*'
	LEFT JOIN SIGAP12.SRY060 SRY ON SRR.RR_ROTEIR = SRY.RY_CALCULO AND SRY.D_E_L_E_T_ <> '*'
WHERE
	SRR.D_E_L_E_T_ <> '*'    