/*CADASTRO SINDICATOS*/

SELECT DISTINCT
	sind.codsin AS '1CODSINDICATO',
	UPPER(CONVERT(CHAR(100), sind.NomSin)) AS '2DESCRICAO',
	RIGHT('00000000000000' + CAST(CAST(SIND.NUMCGC AS VARCHAR) AS VARCHAR(14)),14) AS '3CNPJ',
	'0' AS '4NUMR_Status',
	'1900/01/01' AS '5DATA_Inicial',
	CONVERT(CHAR(10), '') AS '6DATA_Final',
	CONVERT(CHAR(3),  '') AS '7DESC_FPAS',
	CONVERT(CHAR(4),  '') AS '8DESC_Terceiros',
	CASE WHEN SIND.CODSIN = 59 THEN '2910800' 
	     WHEN SIND.CODSIN = 107 THEN '3304557'
		 WHEN SIND.CODSIN = 106 THEN '3304557'
		 ELSE sind.codcid END as '9cidade',
	CASE 
WHEN RTRIM(cid.codest) IS NULL THEN 4
WHEN RTRIM(cid.codest) = 'AC' THEN 0
WHEN RTRIM(cid.codest) = 'AL' THEN 1
WHEN RTRIM(cid.codest) = 'AM' THEN 2
WHEN RTRIM(cid.codest) = 'AP' THEN 3
WHEN RTRIM(cid.codest) = 'BA' THEN 4
WHEN RTRIM(cid.codest) = 'CE' THEN 5
WHEN RTRIM(cid.codest) = 'DF' THEN 6
WHEN RTRIM(cid.codest) = 'ES' THEN 7
WHEN RTRIM(cid.codest) = 'GO' THEN 8
WHEN RTRIM(cid.codest) = 'MA' THEN 9
WHEN RTRIM(cid.codest) = 'MG' THEN 10
WHEN RTRIM(cid.codest) = 'MS' THEN 11
WHEN RTRIM(cid.codest) = 'MT' THEN 12
WHEN RTRIM(cid.codest) = 'PA' THEN 13
WHEN RTRIM(cid.codest) = 'PB' THEN 14
WHEN RTRIM(cid.codest) = 'PE' THEN 15
WHEN RTRIM(cid.codest) = 'PI' THEN 16
WHEN RTRIM(cid.codest) = 'PR' THEN 17
WHEN RTRIM(cid.codest) = 'RJ' THEN 18
WHEN RTRIM(cid.codest) = 'RN' THEN 19
WHEN RTRIM(cid.codest) = 'RO' THEN 20
WHEN RTRIM(cid.codest) = 'RR' THEN 21
WHEN RTRIM(cid.codest) = 'RS' THEN 22
WHEN RTRIM(cid.codest) = 'SC' THEN 23
WHEN RTRIM(cid.codest) = 'SE' THEN 24
WHEN RTRIM(cid.codest) = 'SP' THEN 25
WHEN RTRIM(cid.codest) = 'TO' THEN 26
WHEN RTRIM(cid.codest) = 'ERLA' THEN 69
WHEN RTRIM(cid.codest) = 'LIM' THEN 231
WHEN RTRIM(cid.codest) = 'CARA' THEN 133
WHEN RTRIM(cid.codest) = 'FALC' THEN 290
END AS '10CODG_UF',
sind.endcep AS '11DESC_CEP',
	CASE
		WHEN sind.endrua LIKE '%RUA%' OR sind.endrua LIKE '%R.%'OR sind.endrua LIKE '%RUA:%' THEN '00039'
		WHEN sind.endrua LIKE 'Avenida%' OR sind.endrua LIKE 'Av.%' OR sind.endrua LIKE 'Av %' OR sind.endrua LIKE 'Av:%' THEN '00004'
		WHEN sind.endrua LIKE 'TRAV.%'  THEN '00042'
		WHEN sind.endrua LIKE 'PRACA%'  OR sind.endrua LIKE 'PRAA%' THEN '00033'
		ELSE '00039'
	END AS '12NUMR_TipoLogradouro',
	 CASE WHEN sind.endrua = '' THEN 'ENDERECO PADRAO' ELSE sind.endrua END AS '13DESC_Logradouro',
	 sind.endnum as '14num',
	 sind.endcpl as '15complemento',
	 CASE WHEN bai.nombai IS NULL  THEN 'BAIRRO PADRAO' ELSE bai.nombai END as '16bairro',
	REPLICATE(' ', 10) AS '17DESC_CaixaPostal',
	REPLICATE(' ', 8) AS '18DESC_CEPCaixaPostal',
	REPLICATE(' ', 100) AS '19DESC_NomeContato',
	'' AS '20NUMR_DDTelContato',
	REPLICATE(' ', 16) AS '21DESC_TelContato',
	'' AS '22NUMR_DDCelContato',
	REPLICATE(' ', 16) AS '23DESC_CelContato',
	REPLICATE(' ', 10) AS '24DESC_RamalContato',
	REPLICATE(' ', 100) AS '25DESC_EmailCorpContato',
	REPLICATE(' ', 100) AS '26DESC_EmailPartContato',
	REPLICATE(' ', 100) AS '27DESC_URLContato',
	REPLICATE(' ', 100) AS '28DESC_FacebookContato',
	REPLICATE(' ', 100) AS '29DESC_TwitterContato',
	REPLICATE(' ', 100) AS '30DESC_LinkedInContato',
	codage AS '31CODG_AgenciaBanco',
	codban AS '32CODG_Banco',
	'000000' AS '33CODG_PaisBanco',
	'00' AS '34NUMR_FormaPagamento',
	conban AS '35NUMR_ContaBanco',
	digban AS '36NUMR_DigVerificadorBanco',
	REPLICATE(' ', 3) AS '37NUMR_TipoConta',
	REPLICATE(' ', 5) AS '38VALR_PercContriAssis',
	REPLICATE(' ', 5) AS '39VALR_PercContriConfe',
	REPLICATE(' ', 5) AS '40VALR_PercContriSindc',
	'' AS '41OUTROS_TIPO_CONTRIBUICOES',
	'' AS '42TIPO_CONTR',
	'' AS '43PERC_OUTRAS_CONTR',
	REPLICATE(' ', 5) AS '44VALR_Produtividade', 
	REPLICATE(' ', 5) AS '45VALR_Anuenio', 
	REPLICATE(' ', 5) AS '46VALR_Trienio', 
	REPLICATE(' ', 5) AS '47VALR_Quinquenio', 
	REPLICATE(' ', 5) AS '48VALR_Heptaenio', 
	REPLICATE(' ', 1) AS '49DESC_OutroBeneficio',
	'00' AS '50NUMR_Anos',
	'000' AS '51NUMR_Percentual',
	' ' AS '52DESC_DefCumulativa',
	' ' AS '53DESC_AuxFuneral',
	' ' AS '54DESC_AdicPericulosidade',
	' ' AS '55DESC_AdicInsalubridade',
	'0' AS '56DESC_EntidadeSind', /* Dos Empregados */
	REPLICATE(' ', 15) AS '57CODG_EntidadeSind',
	REPLICATE(' ', 5) AS '58DATA_Base',
	'00' AS '59NUMR_DiasContratoExp',
	'00' AS '60NUMR_DiasProrrContrato',
	'00' AS '61NUMR_DiasContrato',
	'00' AS '62NUMR_DiasProrrContratoTemp',
	'00' AS '63NUMR_DiasContratoDeter',
	'00' AS '64NUMR_DiasProrrContratoDeter',
	'00' AS '65NUMR_MaxHorasSemanais',
	' ' AS '66DESC_FeriasDiasSemestre',
	REPLICATE(' ', 10) AS '67DATA_AcordoSindical',
	REPLICATE(' ', 5) AS '68VALR_UltDissidio',
	REPLICATE(' ', 5) AS '69VALR_HoraExtra',
	REPLICATE(' ', 5) AS '70VALR_AdiNoturno', 
	REPLICATE(' ', 5) AS '71VALR_OutrasHoras',
	'00' AS '72NUMR_ParteVariavel',
	'00' AS '73NUMR_UltimosNMeses',
	'00' AS '74NUMR_MaioresVal',
	REPLICATE(' ', 11) AS '75VALR_PisoGeral'
FROM 
	R014SIN sind
	LEFT JOIN R074BAI bai ON sind.codbai = bai.codbai AND sind.codcid = bai.codcid
	LEFT JOIN R074CID cid ON sind.codcid = cid.codcid
	WHERE sind.codsin NOT IN (204)

Order by 1



/*
SELECT 
	*
FROM 
	R014SIN sind
WHERE
	sind.codsin IN (4,19)


SELECT 
	* 
FROM 
	R074BAI bai
*/


select distinct      
   his.codsin as "Codigo Sindicato Destino",
   UPPER(CONVERT(CHAR(100), sind.NomSin)) AS '2DESCRICAO'
from 
   r038hsi his
	INNER JOIN R034FUN FUN ON 
      his.NUMEMP = FUN.NUMEMP AND
	  his.TIPCOL = FUN.TIPCOL AND
	  his.NUMCAD = FUN.NUMCAD
	LEFT JOIN R042RCM rcm ON 
      FUN.NUMEMP = rcm.NUMEMP AND
	  FUN.TIPCOL = rcm.TIPCOL AND
	  FUN.NUMCAD = rcm.NUMCAD 
	  left join R014SIN sind on
	  his.codsin=sind.codsin
where 
   his.datalt >= fun.datadm
   and (RCm.datdem IS NULL or REPLACE(CONVERT(VARCHAR(10), RCm.datdem, 111), '/', '')>'20171001')
