/*------------------------------------------------------------------------------------------------------------------------------+
|
+------------------------------------------------------------------------------------------------------------------------------*/
/* 
USE ORIGEM_GHC_SENIOR_SJRP_02_09_2022
select distinct histcar.codmot, mot.nommot
from R038HSA histcar
	LEFT JOIN r076mot mot ON
		mot.codmot = histCar.codmot
order by 1
*/


--========================================================================================================
-- Busca o primeiro salrio do colaborador
--========================================================================================================
/*
SELECT
   '010.3' as leiaute,
   ''      as PessoaID,
	CASE WHEN fun.numemp = 1 THEN 304
		 WHEN fun.numemp = 2 THEN 303
		 ELSE '' 
	END AS '2CdiEmpresa', 			
   dbo.fnc_depara( CAST(fun.numemp AS VARCHAR)+'_'+CAST(fun.tipcol AS VARCHAR) + '_'+CAST(fun.numcad AS VARCHAR), 'MATRICULA', 'HMC-IMC-SJRP') AS "1 Matrcula (Colaborador)",         
   dbo.fnc_depara( hsa.codmot, 'MOTSALARIO', 'HMC-IMC-SJRP')  AS "Tipo Motivo",
	convert(decimal(18,2), hsa.valsal) AS "Salario"
FROM 
	R038HSA hsa
	INNER JOIN R034FUN FUN ON 
		hsa.NUMEMP = FUN.NUMEMP AND 
		hsa.TIPCOL = FUN.TIPCOL	AND 
		hsa.NUMCAD = FUN.NUMCAD
	LEFT JOIN r076mot mot ON
		mot.codmot = hsa.codmot
	INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG ON 
		FUN.numemp=MIG.NUMEMP AND 
		FUN.TIPCOL=MIG.TIPCOL AND 
		FUN.numCAD=MIG.NUMCAD
WHERE
   fun.TIPCOL = 1 AND 
   hsa.datalt = fun.datadm and
   (fun.sitafa <> 7 or
   (fun.sitafa = 7 and fun.datafa >= '01/01/2017')) --Demitido
  
ORDER BY hsa.numemp, hsa.numcad, CONVERT(DATE, hsa.datalt, 103)
	
	*/




--========================================================================================================
-- Movimentaes Salarial
--========================================================================================================
--
-- Se atentar nos motivos do reajuste salarial, pois os motivos que envolvem acordo/dissdio/conveno
-- o campo, Data de alterao  obrigatrio
--
--========================================================================================================


SELECT
	'Ento' AS "Ento",
	row_number() over (order by hsa.numemp, hsa.numcad, CONVERT(DATE, hsa.datalt, 103)) AS "ID",
	'NO' AS "Ignorar",
	CONVERT(varchar, hsa.datalt, 103) AS "Data Movimentao",
--	hsa.numemp AS "Codigo da empresa",
	CASE WHEN fun.numemp = 1 THEN 304
		 WHEN fun.numemp = 2 THEN 303
		 ELSE '' 
	END AS '2CdiEmpresa', 			
   dbo.fnc_depara( CAST(fun.numemp AS VARCHAR)+'_'+CAST(fun.tipcol AS VARCHAR) + '_'+CAST(fun.numcad AS VARCHAR), 'MATRICULA', 'HMC-IMC-SJRP') AS "1 Matrcula (Colaborador)",         	
   dbo.fnc_depara( hsa.codmot, 'MOTSALARIO', 'HMC-IMC-SJRP')  AS "Codigo do Motivo da Movimentao", 
	UPPER(mot.nommot) AS "Descrio",
	'CARGO_EFETIVO' AS "Tipo de Salario",
	'INFORMADO'     AS "Tipo de Reajuste",
	REPLACE(CONVERT(VARCHAR,hsa.valsal),'.',',') AS "Proximo Salario",
	'SIM' AS "Efetuar o reajuste mesmo que o novo salario for menor que o atual",
	CASE WHEN hsa.codmot IN (6,9,14) THEN CONVERT(varchar, hsa.datalt, 103) ELSE '' END AS DATA
	--,CONVERT(varchar, hsa.datalt, 103)
	--,SUBSTRING(CONVERT(varchar, hsa.datalt, 103),7,4)+SUBSTRING(CONVERT(varchar, hsa.datalt, 103),4,2)+SUBSTRING(CONVERT(varchar, hsa.datalt, 103),1,2)
	--,REPLACE(TAR.DTRESC,'/','')
FROM 
	R038HSA hsa
	INNER JOIN R034FUN FUN ON 
		hsa.NUMEMP = FUN.NUMEMP 
		AND hsa.TIPCOL = FUN.TIPCOL
		AND hsa.NUMCAD = FUN.NUMCAD
	LEFT JOIN r076mot mot ON
		mot.codmot = hsa.codmot
	INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG ON 
		FUN.numemp=MIG.NUMEMP AND 
		FUN.TIPCOL=MIG.TIPCOL AND 
		FUN.numCAD=MIG.NUMCAD
	left join tb_aux_resc tar ON
		HSA.numemp=TAR.NUMEMP AND 
		HSA.TIPCOL=TAR.TIPCOL AND 
		HSA.numCAD=TAR.NUMCAD
WHERE 
   fun.numemp in (1,2) AND 
   fun.TIPCOL = 1 AND 
   hsa.datalt > fun.datadm and
   (fun.sitafa <> 7 or
   (fun.sitafa = 7 and fun.datafa >= '01/01/2017')) --Demitido
   and (SUBSTRING(CONVERT(varchar, hsa.datalt, 103),7,4)+SUBSTRING(CONVERT(varchar, hsa.datalt, 103),4,2)+SUBSTRING(CONVERT(varchar, hsa.datalt, 103),1,2)<REPLACE(TAR.DTRESC,'/','') OR REPLACE(TAR.DTRESC,'/','') IS NULL)
   --AND dbo.fnc_depara( hsa.NUMCAD, 'MATRICULA', 'ISL') NOT LIKE ('%DePara No Encontrado') 
   --AND dbo.fnc_depara( hsa.NUMCAD, 'MATRICULA', 'ISL') > 6183
   --AND NOT EXISTS (select 1 from ORIGEM_SIRIO_21_08_2021.R038HSA x where x.numemp = hsa.numemp and x.numcad= hsa.numcad and x.datalt = hsa.datalt)
   --AND hsa.NUMCAD IN (578345302)   
   --AND  CONVERT(DATE, hsa.datalt, 103) >= '01/11/2021'
	--AND NOT EXISTS (select 1 from ORIGEM_SIRIO_09_12_2021.R038HSA x where x.numemp = hsa.numemp and x.numcad= hsa.numcad and x.datalt = hsa.datalt)
ORDER BY hsa.numemp, hsa.numcad, CONVERT(DATE, hsa.datalt, 103)


-- EXCLUSO

/*
select 
   hsa.numemp AS "Codigo da empresa",
   dbo.fnc_depara( CAST(fun.numemp AS VARCHAR)+'_'+CAST(fun.tipcol AS VARCHAR) + '_'+CAST(fun.numcad AS VARCHAR), 'MATRICULA', 'HMC-IMC-SJRP') AS "Matrcula (Colaborador)",         	
   replace(convert(varchar, hsa.datalt, 102), '.', '/') as "Data Movimentao",
   '' as sequencial,
   '' as 'Excluir Lote',
   '1254'  as "Tipo Movimentacao"
from 
   R038HSA hsa
   INNER JOIN R034FUN FUN ON 
      hsa.NUMEMP = FUN.NUMEMP AND
	  hsa.TIPCOL = FUN.TIPCOL AND
	  hsa.NUMCAD = FUN.NUMCAD
   INNER JOIN TB_AUX_FUNCIONARIOS_MIGRADOS MIG ON 
	  FUN.numemp=MIG.NUMEMP AND 
	  FUN.TIPCOL=MIG.TIPCOL AND 
	  FUN.numCAD=MIG.NUMCAD
where 
    FUN.TIPCOL = 1 and
   (fun.sitafa <> 7 or
   (fun.sitafa = 7 and fun.datafa >= '01/01/2017')) --Demitido
   --AND NOT EXISTS (select 1 from ORIGEM_SIRIO_09_12_2021.R038HSA x where x.numemp = hsa.numemp and x.numcad= hsa.numcad and x.datalt = hsa.datalt)
order by hsa.numcad, hsa.datalt desc
*/