/**********************************************************************************************************************/
/********** PROJETO GHC - BASE SENIOR - SJRP - 2022 *******************************************************************/
/********** MIGRAO DE FICHA FINANCEIRA ******************************************************************************/
/**********************************************************************************************************************/
/* SCRIPT 01 - IMPORTAO E VALIDAO DOS DEPARAS DE EVENTOS E FOLHA                                                  */
/**********************************************************************************************************************/
/* SOMENTE NUMEMP 1 E 2                                                                                               */
/**********************************************************************************************************************/

--> SOMENTE NUMEMP 1 (304) E 2 (303)

--> TABELAS SENIOR UTLIZADAS NA MIGRAO
------------------------------------------------------------------------------------------------------------------------
SELECT * FROM R046VER --> TABELA DE HISTORICO DE EVENTOS CALCULADOS
SELECT * FROM R042RCV --> TABELA DE HISTORICO DE EVENTOS CALCULADOS PARA RESCISAO
SELECT * FROM R040FEV --> TABELA DE HISTORICO DE EVENTOS CALCULADOS PARA FERIAS
SELECT * FROM R008EVC --> TABELA DE CADASTRO DE EVENTOS
SELECT * FROM R044CAL --> TABELA DE CALCULOS PROCESSADOS

SELECT * FROM R046IRF --> TABELA PARA MIGRAO DAS BASES
SELECT * FROM R054CTD --> TABELA PARA MIGRAO DAS BASES
SELECT * FROM R056DEP --> TABELA PARA MIGRAO DAS BASES
SELECT * FROM R146PRV --> TABELA PARA MIGRAO DAS BASES


--> CRIANDO TABELA DE APOIO COM OS DADOS DOS TIPOS DE FOLHAS DA SENIOR
------------------------------------------------------------------------------------------------------------------------
CREATE TABLE TIPOCALCULO_SENIOR (
CODIGO INT,
DESCRICAO VARCHAR(255));

SELECT * FROM TIPOCALCULO_SENIOR

/*
INSERT INTO TIPOCALCULO_SENIOR VALUES (11, 'Mensal')
INSERT INTO TIPOCALCULO_SENIOR VALUES (12, 'Mensal Complementar')
INSERT INTO TIPOCALCULO_SENIOR VALUES (13, 'Dissidio Complementar')
INSERT INTO TIPOCALCULO_SENIOR VALUES (14, 'Dissidio')
INSERT INTO TIPOCALCULO_SENIOR VALUES (15, 'Rescisao Complementar')
INSERT INTO TIPOCALCULO_SENIOR VALUES (21, 'Primeira Semana')
INSERT INTO TIPOCALCULO_SENIOR VALUES (22, 'Semana Intermediaria')
INSERT INTO TIPOCALCULO_SENIOR VALUES (23, 'Ultima Semana')
INSERT INTO TIPOCALCULO_SENIOR VALUES (31, 'Adiantamento 13 Salario')
INSERT INTO TIPOCALCULO_SENIOR VALUES (32, '13 Salario Integral')
INSERT INTO TIPOCALCULO_SENIOR VALUES (41, 'Primeira Quinzena')
INSERT INTO TIPOCALCULO_SENIOR VALUES (42, 'Segunda Quinzena')
INSERT INTO TIPOCALCULO_SENIOR VALUES (91, 'Adiantamento Salarial')
INSERT INTO TIPOCALCULO_SENIOR VALUES (92, 'Participacao Lucros e Resultados')
INSERT INTO TIPOCALCULO_SENIOR VALUES (93, 'Especiais')
INSERT INTO TIPOCALCULO_SENIOR VALUES (94, 'Reclamatoria Trabalhista')

*/



--> SCRIPT PARA GERAR O DEPARA DE FOLHA
------------------------------------------------------------------------------------------------------------------------
SELECT C.tipcal, T.DESCRICAO, COUNT(*) AS QTDE 
  FROM R044CAL C
       INNER JOIN TIPOCALCULO_SENIOR T
	   ON (T.CODIGO = C.tipcal)
 WHERE C.numemp IN (1,2)
 GROUP BY C.tipcal, T.DESCRICAO 
 ORDER BY C.tipcal

/* FOLHA ESPECIAL
SELECT * FROM R044CAL WHERE tipcal = 93
SELECT * FROM R046VER WHERE codcal = 487
*/


--> CRIANDO TABELA PARA DEPARA DE FOLHA
------------------------------------------------------------------------------------------------------------------------
CREATE TABLE DEPARA_FOLHA_SENIOR (
COD_FOLHA_SENIOR INT,
DESC_FOLHA_SENIOR VARCHAR(255),
COD_FOLHA_LG INT,
DESC_FOLHA_LG VARCHAR(255)
);

CREATE UNIQUE INDEX IDX_DEPARA_FOLHA_01 ON DEPARA_FOLHA_SENIOR(COD_FOLHA_SENIOR)

SELECT * FROM DEPARA_FOLHA_SENIOR

/*
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (11, 'Mensal', 1, 'MENSAL');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (12, 'Mensal Complementar', 40, 'COMPLEMENTAR EXTRA');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (13, 'Dissidio Complementar', 1, 'MENSAL');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (14, 'Dissidio', 1, 'MENSAL');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (15, 'Rescisao Complementar', 8, 'RESCISAO COMP FORA DO MES');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (21, 'Primeira Semana', 13, 'COMPLEMENTAR DIAS 01 A 10');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (22, 'Semana Intermediaria', 14, 'COMPLEMENTAR DIAS 11 A 20');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (23, 'Ultima Semana', 16, 'COMPLEMENTAR DIAS 21 A 31');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (31, 'Adiantamento 13 Salario', 3, 'ADIANTAMENTO 13 SALARIO');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (32, '13 Salario Integral', 4, '13 SALARIO');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (41, 'Primeira Quinzena', 13, 'COMPLEMENTAR DIAS 01 A 10');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (42, 'Segunda Quinzena', 16, 'COMPLEMENTAR DIAS 21 A 31');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (91, 'Adiantamento Salarial', 6, 'ADIANTAMENTO QUINZENAL');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (92, 'Participacao Lucros e Resultados', 15, 'PARTICIP LUCROS/RESULTADOS');
INSERT INTO DEPARA_FOLHA_SENIOR VALUES (93, 'Especiais', 1, 'MENSAL');
*/

--> CRIANDO TABELA DE DEPARA DE EVENTOS (EXECUTAR SOMENTE SE ELA NO ESTIVER CRIADA)
-----------------------------------------------------------------------------------------------------------------
/*

SELECT *
  INTO DEPARA_EVENTOS_V3
  FROM DEPARA_EVENTOS_ATUAL
*/
-- TRUNCATE TABLE DEPARA_EVENTOS_ATUAL
-- DROP TABLE DEPARA_EVENTOS_ATUAL
CREATE TABLE DEPARA_EVENTOS_ATUAL (
VERSAO					INT,
COD_EVENTO_DE			BIGINT,
COD_FOLHA_DE			VARCHAR(255),
EVENTO_DE				VARCHAR(255),
TIPO_EVENTO_DE			VARCHAR(255),
COD_EVENTO_LG			BIGINT,
COD_FOLHA_LG			VARCHAR(255),
EVENTO_LG				VARCHAR(255),
TIPO_EVENTO_LG			VARCHAR(255),
COD_EVENTO_REFER_LG		BIGINT,
EVENTO_REFER_LG			VARCHAR(255),
COD_REGRA_EVE_REFER		VARCHAR(255),
APLIC_REGRA_EVE_REFER	VARCHAR(255));

CREATE UNIQUE INDEX IDX_DEPARA_EVENTO_01 ON DEPARA_EVENTOS_ATUAL(COD_EVENTO_DE,COD_EVENTO_LG,COD_FOLHA_LG)
CREATE INDEX IDX_DEPARA_EVENTO_02 ON DEPARA_EVENTOS_ATUAL(COD_FOLHA_LG)

SELECT * FROM DEPARA_EVENTOS_ATUAL


--> CRIANDO TABELA DE EVENTOS NO MIGRADOS (EXECUTAR SOMENTE SE ELA NO ESTIVER CRIADA)
-----------------------------------------------------------------------------------------------------------------
-- DROP TABLE TB_FOLHA_EVENTOS_NAO_MIGRADOS
CREATE TABLE TB_FOLHA_EVENTOS_NAO_MIGRADOS (COD_EVENTO_DE BIGINT)

CREATE UNIQUE INDEX IDX_DEPARA_EVENTO_NAO_MIG_01 ON TB_FOLHA_EVENTOS_NAO_MIGRADOS(COD_EVENTO_DE)


--> VALIDANDO SE EXISTE REGRAS DUPLICADAS APS A IMPORTAO DA PLANILHA
-----------------------------------------------------------------------------------------------------------------
CREATE VIEW VW_DEPARA_EVENTOS_REGRAS_DUP AS
SELECT COD_EVENTO_DE, COD_EVENTO_LG, COD_FOLHA_LG, COUNT(*) AS QTDE 
  FROM DEPARA_EVENTOS_ATUAL 
 GROUP BY COD_EVENTO_DE, COD_EVENTO_LG, COD_FOLHA_LG
HAVING COUNT(*) > 1


--: EXECUTAR A CONSULTA ABAIXO E SE RETORNAR SITUAES DUPLICADAS PASSAR PARA A CONSULTORA (XIMENES) VERIFICAR
--  EXECUTAR TODAS AS VEZES QUE FOR IMPLEMENTADO UMA NOVA VERSO DO DEPARA
SELECT DP.* 
  FROM DEPARA_EVENTOS_ATUAL DP
       INNER JOIN VW_DEPARA_EVENTOS_REGRAS_DUP DUP
	   ON (DUP.COD_EVENTO_DE = DP.COD_EVENTO_DE AND DUP.COD_EVENTO_LG = DP.COD_EVENTO_LG AND DUP.COD_FOLHA_LG = DP.COD_FOLHA_LG)
 ORDER BY DP.COD_EVENTO_DE, DP.COD_EVENTO_LG, DP.COD_FOLHA_LG


--> CRIANDO VIEW COM A LISTA DE RUBRICAS ENVIADAS NA BASE DA SENIOR
-----------------------------------------------------------------------------------------------------------------
CREATE VIEW VW_LISTA_EVENTOS_SENIOR AS
SELECT DISTINCT VA.tabeve, VA.codeve, EV.deseve
  FROM R046VER VA --> TABELA DE HISTORICO DE EVENTOS CALCULADOS
       INNER JOIN R008EVC EV --> TABELA DE CADASTRO DE EVENTOS
	   ON (EV.codtab = VA.tabeve AND EV.codeve = VA.codeve)
 WHERE VA.numemp IN (1,2)
UNION
SELECT DISTINCT VA.tabeve, VA.codeve, EV.deseve
  FROM R042RCV VA --> TABELA DE HISTORICO DE EVENTOS CALCULADOS PARA RESCISAO
       INNER JOIN R008EVC EV --> TABELA DE CADASTRO DE EVENTOS
	   ON (EV.codtab = VA.tabeve AND EV.codeve = VA.codeve)
 WHERE VA.numemp IN (1,2)
UNION
SELECT DISTINCT VA.tabeve, VA.codeve, EV.deseve
  FROM R040FEV VA --> TABELA DE HISTORICO DE EVENTOS CALCULADOS PARA FERIAS
       INNER JOIN R008EVC EV --> TABELA DE CADASTRO DE EVENTOS
	   ON (EV.codtab = VA.tabeve AND EV.codeve = VA.codeve)
 WHERE VA.numemp IN (1,2)
ORDER BY 1,2


--> VALIDANDO SE EXISTE REGRAS (VERBAS X FOLHA) CALCULADAS NA SENIOR E NO ENCONTRADAS NO DEPARA
-----------------------------------------------------------------------------------------------------------------
SELECT EVDE.codeve AS COD_EVENTO, 
       ISNULL(UPPER(EVDE.deseve),'CADASTRO RUBRICA NO ENCONTRADA') AS EVENTO
  FROM VW_LISTA_EVENTOS_SENIOR EVDE
       LEFT OUTER JOIN DEPARA_EVENTOS_ATUAL DP
	   ON (DP.COD_EVENTO_DE = EVDE.codeve)
 WHERE NOT EXISTS (SELECT 1
                     FROM TB_FOLHA_EVENTOS_NAO_MIGRADOS NM
					 WHERE NM.COD_EVENTO_DE = EVDE.codeve)
   AND DP.COD_EVENTO_LG IS NULL
 ORDER BY 1




--> CRIANDO TABELA PARA IMPORTAR OS EVENTOS ATUAIS J CADASTRADOS NA BASE DA LG
-----------------------------------------------------------------------------------------------------------------
-- TRUNCATE TABLE [Eventos_LG]
CREATE TABLE [dbo].[Eventos_LG](
	[CODIGO_EVENTO] [varchar](500) NULL,
	[EVENTO] [varchar](500) NULL,
	[CODIGO_TIPO_EVENTO] [varchar](500) NULL,
	[TIPO_EVENTO] [varchar](500) NULL,
	[CODIGO_ORIENTADOR] [varchar](500) NULL,
	[ORIENTADOR] [varchar](500) NULL,
	[ATUAL] [varchar](500) NULL
) ON [PRIMARY]
GO

CREATE INDEX IDX_Eventos_LG ON Eventos_LG(CODIGO_EVENTO);

SELECT * FROM [Eventos_LG]



--> VALIDANDO SE EXISTEM EVENTOS NO DEPARA QUE NO FORAM CADASTRADOS NA BASE DA LG
-----------------------------------------------------------------------------------------------------------------
SELECT DISTINCT DPE.COD_EVENTO_LG,
       DPE.EVENTO_LG AS EVENTO
  FROM DEPARA_EVENTOS_ATUAL DPE
 WHERE NOT EXISTS (SELECT 1 FROM EVENTOS_LG EV WHERE EV.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
UNION
SELECT DISTINCT DPE.COD_EVENTO_REFER_LG,
       DPE.EVENTO_REFER_LG AS EVENTO
  FROM DEPARA_EVENTOS_ATUAL DPE
 WHERE NOT EXISTS (SELECT 1 FROM EVENTOS_LG EV WHERE EV.CODIGO_EVENTO = DPE.COD_EVENTO_REFER_LG)
   AND DPE.COD_EVENTO_REFER_LG > 0



--> VALIDANDO SE EXISTEM EVENTOS NO DEPARA COM TIPOS DIFERENTES ENTRE AS BASES
-----------------------------------------------------------------------------------------------------------------
SELECT DPE.COD_EVENTO_DE, EV.deseve, 
       CASE EV.TIPEVE WHEN 1 THEN 'Provento'
			          WHEN 2 THEN 'Vantagem'
			          WHEN 3 THEN 'Desconto'
			          WHEN 4 THEN 'Outros'
			          WHEN 5 THEN 'Outros Env. Provento'
			          WHEN 6 THEN 'Outros Env. Desconto'
	   END AS TIPO_EVENTO,
       DPE.COD_EVENTO_LG,
	   LG.EVENTO AS EVENTO_LG,
	   LG.CODIGO_TIPO_EVENTO,
	   LG.TIPO_EVENTO,
	   LG.ORIENTADOR
  FROM DEPARA_EVENTOS_ATUAL DPE
       INNER JOIN Eventos_LG LG
	   ON (LG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
       LEFT OUTER JOIN R008EVC EV
	   ON (EV.codeve = DPE.COD_EVENTO_DE)
 WHERE (
         --> PROVENTOS PARA DESCONTOS
         (EV.TIPEVE IN (1,5,2) AND LG.CODIGO_TIPO_EVENTO = 1)
	     OR
	     --> DESCONTOS PARA PROVENTOS
	     (EV.TIPEVE IN (3,6) AND LG.CODIGO_TIPO_EVENTO = 0)
	     OR
	     --> BASES PARA PROVENTOS E DESCONTOS
         --(EV.TIPOEVENTO IN (4,7) AND LG.CODIGO_TIPO_EVENTO IN (0,1))
	     --OR
	     --> PROVENTOS E DESCONTOS PARA BASES
         (EV.TIPEVE IN (1,5,2,3,6) AND LG.CODIGO_TIPO_EVENTO = 2 AND DPE.COD_FOLHA_LG NOT IN (32,33) /*AND DPE.COD_EVENTO_LG NOT IN (13100,13000,13130)*/)
	   )



SELECT DPE.COD_EVENTO_DE, EV.deseve, 
       CASE EV.TIPEVE WHEN 1 THEN 'Provento'
			          WHEN 2 THEN 'Vantagem'
			          WHEN 3 THEN 'Desconto'
			          WHEN 4 THEN 'Outros'
			          WHEN 5 THEN 'Outros Env. Provento'
			          WHEN 6 THEN 'Outros Env. Desconto'
	   END AS TIPO_EVENTO,
       DPE.COD_EVENTO_LG,
	   LG.EVENTO AS EVENTO_LG,
	   LG.CODIGO_TIPO_EVENTO,
	   LG.TIPO_EVENTO,
	   LG.ORIENTADOR
  FROM DEPARA_EVENTOS_ATUAL DPE
       INNER JOIN Eventos_LG LG
	   ON (LG.CODIGO_EVENTO = DPE.COD_EVENTO_LG)
       LEFT OUTER JOIN R008EVC EV
	   ON (EV.codeve = DPE.COD_EVENTO_DE)
 WHERE DPE.COD_EVENTO_DE NOT IN (130,394,264,128)
   AND (
         --> PROVENTOS PARA DESCONTOS
         (EV.TIPEVE IN (1,5,2) AND LG.CODIGO_TIPO_EVENTO = 1)
	     OR
	     --> DESCONTOS PARA PROVENTOS
	     (EV.TIPEVE IN (3,6) AND LG.CODIGO_TIPO_EVENTO = 0)
	     OR
	     --> BASES PARA PROVENTOS E DESCONTOS
         --(EV.TIPOEVENTO IN (4,7) AND LG.CODIGO_TIPO_EVENTO IN (0,1))
	     --OR
	     --> PROVENTOS E DESCONTOS PARA BASES
         (EV.TIPEVE IN (1,5,2,3,6) AND LG.CODIGO_TIPO_EVENTO = 2 AND DPE.COD_FOLHA_LG NOT IN (32,33) /*AND DPE.COD_EVENTO_LG NOT IN (13100,13000,13130)*/)
	   )



