<?php
namespace Financeiro\Repositories;

class Movbancario extends \Doctrine\ORM\EntityRepository
{
    public function queryMovimentoBancario($params){
        $sql = <<<SQL
                   SELECT  MOV.CDREDUCONT,
                           MOV.NRMOVBANC,
                           MOV.DTMOVBANC,
                           MOV.IDMOVBANC,
                           MOV.NRDOCMBANC,
                           MOV.DSHISMBANC,
                           (CASE
                              WHEN MOV.IDMOVBANC = 'D' THEN (MOV.VRMOVBANC * -1)
                              ELSE MOV.VRMOVBANC
                            END
                           ) VRMOVBANC,
                           MOV.IDSTCONEXT,
                           MOV.IDCONCBANC,
                           MOV.CDSEQUEXBA,
                           MOV.NRSEQMOVREBA,
                           MOV.IDERCONEXT,
                           MOV.NRCONCIMOVB,
                           MOV.IDORIGMBANC,
                           MOV.IDSTATUSCTBBANC,
                           MOV.NRMOVBANCORIG,
                           MOV.NRORG,
                           CON.CDBANCO,
                           CON.CDAGENCIA,
                           CON.CDCONTCORR,
                           CON.DSCONTCORR,
                           BAN.NMBANCO
                    FROM MOVBANCARIO MOV, CONTCORR CON, BANCO BAN
                    WHERE (MOV.CDREDUCONT  = :P_CDREDUCONT) AND
                          (MOV.DTMOVBANC BETWEEN :P_DTINICIAL AND :P_DTFINAL OR :P_TDATAS = 'T') AND
                          ((MOV.VRMOVBANC   = :P_VALOR) OR (:P_TVALOR = 0))            AND
                          (MOV.IDSTCONEXT   = :P_IDSTATUS OR :P_IDSTATUS = 'T')        AND
                          (MOV.NRCONCIMOVB  = :P_NRCONCIMOVB OR :P_NRCONCIMOVB = 'T')  AND
                          (MOV.NRORG        = CON.NRORG)                               AND
                          (MOV.CDREDUCONT   = CON.CDREDUCONT)                          AND
                          (CON.CDBANCO      = BAN.CDBANCO)                             AND
                          (MOV.NRMOVBANC   = :P_NRMOVBANC OR :P_NRMOVBANC = 'T')      AND
                          (MOV.CDSEQUEXBA   = :P_CDSEQUEXBA OR :P_CDSEQUEXBA = 'T')    AND
                          (MOV.NRSEQMOVREBA = :P_NRSEQMOVREBA OR :P_NRSEQMOVREBA = 'T')
                    ORDER BY
                           MOV.DTMOVBANC,
                           MOV.NRDOCMBANC,
                           MOV.VRMOVBANC
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function querySaldoMovimentacao($nrorg, $cdreducont, $dtmovbanc){
        $sql = <<<SQL
                  SELECT
                      DTMOVBANC,
                      SUM(VRMOVBANC) AS VRSDOMOV
                    FROM
                       (SELECT
                           DTMOVBANC,
                           VRMOVBANC
                         FROM
                           MOVBANCARIO
                        WHERE
                           (CDREDUCONT = :P_CDREDUCONT) AND
                           (DTMOVBANC >= :P_DTMOVBANC)  AND
                           (NRORG      = :P_NRORG)      AND
                           (IDMOVBANC  = 'C')
                        UNION ALL
                        SELECT
                           DTMOVBANC,
                           VRMOVBANC * -1
                         FROM
                           MOVBANCARIO
                        WHERE
                           (CDREDUCONT = :P_CDREDUCONT) AND
                           (DTMOVBANC >= :P_DTMOVBANC)  AND
                           (NRORG      = :P_NRORG)      AND
                           (IDMOVBANC  = 'D')
                        )
                    GROUP BY
                       DTMOVBANC
SQL;

        $params = array(
            'P_NRORG' => $nrorg,
            'P_CDREDUCONT' => $cdreducont,
            'P_DTMOVBANC' => $dtmovbanc
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }
}